;Assemblieren mit
;a86 =portfolio sources.asm  liefert Programm fr Portfolio
;a86 sources.asm   erzeugt Programm fr PC/XT/AT

;Teil 0 des Basicinterpreters

version macro
 db '1.11'
#em


;Macrodefinitionen

allpush macro
 push bx
 push cx
 push dx
 push bp
 push di
 push si
#em

allpop macro
 pop  si
 pop  di
 pop  bp
 pop  dx
 pop  cx
 pop  bx
#em

negdxbx macro
 not  bx
 not  dx
 add  bx,1
 adc  dx,0
#em

;setzt ein Prozessorregister auf 0, z.B.  clr ax
;!Achtung!, beeinflut auch das C-Flag
clr macro
 xor #1,#1
#em

pushdxbx macro
 push dx
 push bx
#em

popdxbx macro
 pop  bx
 pop  dx
#em

popcxax macro
 pop  ax
 pop  cx
#em

;liefert ein gesetztes C-Flag wenn die Daten zum Befehl
;an der Stelle SI zu ende sind, sonst NC
endtst macro
 cmp b[si],010h
#em

mov_esds macro
 mov  bp,ds
 mov  es,bp
#em

fdipush macro
 push w[di]
 push w[di+2]
 push w[di+4]
 push w[di+6]
#em

fdipop macro
 pop  w[di+6]
 pop  w[di+4]
 pop  w[di+2]
 pop  w[di]
#em

fbppush macro
 push w[bp]
 push w[bp+2]
 push w[bp+4]
 push w[bp+6]
#em

fbppop macro
 pop  w[bp+6]
 pop  w[bp+4]
 pop  w[bp+2]
 pop  w[bp]
#em

movs4w macro ;ist nur 4 Byte lang, also krzer als mov cx,... rep...
 movsw
 movsw
 movsw
 movsw
#em

zuetb equ 3 ;Summand zum berspringen von Zeilennummer und Lngenbyte
regvars equ 12 ;Anzahl der Registervariablen

;pofo-Basic fr Intel 8088/8086


 ORG  100H ;Standard-Startadresse fr *.COM-Files

START:
 JMP  START1

SCRNADR: dw 0 ;Startsegment Bildspeicher fr Text

;einige Variablen fr den Interpreter, werden alle initialisiert
BSTACK: DW 0 ;Obergrenze Stack
STKLMT: DW 0 ;bis hier darf Stack durch Basicbefehle gefllt werden
BUFFER: DW 0 ;Anfang Eingabepuffer (128 Zeichen)
BASBUF: DW 0 ;Interpreterpuffer (256 Byte)
VARBGN: DW 0 ;aufwrts: Variablen A-Z
VARREG: DW 0 ;aufwrts: Registervariablen (32Bit)
VARFPT: dw 0 ;aufwrts: Float-Variablen A#-Z#
VARFLD: DW 0 ;abwrts: Feldvariablen, auf dieser Adresse ist @(0)
TXTEND: DW 0 ;zeigt hinter Quelltextspeicher
TXTUNF: DW 0 ;zeigt hinter Quelltext
CURRNT: DW 0 ;zeigt auf Anfang der interpret. Zeile

;die Variablen, die vom Interpreter initialisiert werden,
;sind mit * im Kommentar gekennzeichnet
DAT_PTR:  dw 0 ;* DATA-Zeiger (RESTORE, READ)
RND_CNT:  DW 0 ;* RND-Zhler
RND_SRG:  DW 0 ;* RND-Schieberegister
RND_BIT:  DB 8,13,16,4 ;Ausgnge+1 des RND_SRG
PRT_SPC:  DW 0 ;* Zahlenformat bei PRINT
PRT_WAY:  dw 0 ;* Ausgabeumleitung
SAV_INT:  DW 0,0,0,0 ;*fr die alten INT$1B, $24-Vektoren
PRG_BRK:  DB 0 ;*wird durch Fn+B gesetzt: Programmabbruch
TRI_MOD:  db 0 ;* Modus der trigonometrischen Funktionen
TOK_LBY:  dw 0 ;* fr Tokenisierung

;Variablen fr Graphik, werden alle initialisiert
G_AX: DB 0 ;linke obere Ecke des Clippings
G_AY: DB 0 ; -"-
G_EX: DB 0 ;rechte untere Ecke des Clippings
G_EY: DB 0 ; -"-
G_X:  DB 0 ;Kursor
G_Y:  DB 0 ; -"-
G_HX: DB 0 ;Anzahl Hardware-Spalten
G_HY: DB 0 ;Anzahl Hardware-Zeilen
G_CO: DB 0 ;Farbe/Zeichenmodus
G_MO: DB 0 ;Bildschirmmodus
G_PA: DB 0 ;Nummer der Bildschirmseite, meist 0
T_MO: db 0 ;Steuersequenzflag
G_ZG: dw 0 ;Startadr. Zeichengenerator fr Graphikmodus
G_RO: dw 0 ;Textrotation 0,6,12,...,42 (entgegen Uhrzeiger)

;Floating Point Register, mssen so hintereinander liegen
FPR0: dw 0,0,0,0 ;Ergebnis
FPR1: dw 0,0,0,0 ;Operand 1
FPR2: dw 0,0,0,0 ;Operand 2


RUNINIT:
;wird vor RUN und Interpretation im Direktmodus aufgerufen
;out: ax=0
 call TOTEXTM      ;Textmodus
 pop  bx           ;Ret.adr.
 xor  ax,ax
 mov  [PRG_BRK],al ;noch kein BREAK
 mov  sp,[BSTACK]
 push ax           ;noch kein Basicelement auf Stack
 jmp  bx           ;statt RET


IGNBLNK:
;incr. SI soweit (falls berhaupt), bis es nicht mehr auf Spaces zeigt
;incr. SI nochmal, falls es auf Suchzeichen zeigte
;in:  SI: Textzeiger
;     AH: Suchzeichen
;out: SI: Textzeiger
;     AL: Textzeichen auf das SI zeigt
;     Flags: von CMP Zeichen,Suchzeichen
;fre: alle anderen Register
 cld
ignblnk1:
 lodsb         ;hole Zeichen
 cmp  al,020H
 jz   ignblnk1 ;berspringe Spaces
 cmp  al,ah    ;Suchzeichen gefunden ?
 jnz  ignblnk2 ; nein, SI zeigt hinter Space
 lodsb         ; ja, nchstes Zeichen holen
ignblnk2:      ;SI zeigt eins zu weit!
 lahf
 dec  si
 sahf
 ret


START1:
 MOV  AX,SP
 MOV  [BSTACK],AX   ;Stackanfang (abwrts)
 SUB  AX,0400H      ;dieser Bereich kann durch Basicbefehle gefllt werden
 MOV  [STKLMT],AX   ;Beginn zustzlichen Stackplatzes (abwrts)
 SUB  AX,0400H+080H ;Stack+Eingabepuffer
 MOV  [BUFFER],AX   ;Beginn des Eingabe/INPUT/Filename puffers
 SUB  AX,0100H      ; (aufwrts)
 MOV  [BASBUF],AX   ;Basiczeilenpuffer, mu hinter [TXTEND] liegen
 SUB  AX,26*4       ; als Zeichen fr Direktmodus (aufwrts)
 MOV  [VARBGN],AX   ;Beginn der Variablen A-Z (aufwrts)
 SUB  AX,regvars*4
 MOV  [VARREG],AX   ;Beginn der Registervariablen AX-EN (aufwrts)
 sub  ax,26*8
 mov  [VARFPT],ax   ;Beginn der Float-Var. A#-Z# (aufwrts)
 sub  ax,8          ;Beginn der Float-Feldvariablen @(i)- (abwrts)
 MOV  [VARFLD],AX   ;@(0) liegt auf dieser Adresse
 MOV  [TXTEND],AX   ;Ende des Quelltextspeichers
;hier knnte noch ein Test folgen, ob der Speicher berhaupt reicht:
; AX mu grer sein als TXTBGN sonst Fehlermeldung
 mov  bx,01000h     ;64KByte reservieren, Rest freigeben
 mov  ah,04ah       ;wenn weniger frei, Fehlerrckmeldung, aber kein Schaden
 int  021h          ;INT$21 Func$4A: setze Speicherblock
start2:
 mov  ax,TXTBGN ;NEW ausfhren
 mov  [TXTUNF],ax
 CALL STEXTM    ;Textmodus

 MOV  AX,0351BH ;sichere alten [Fn]+[B] Vektor
 INT  021H      ;INT$21 Func$35: Lies Interruptvektor
 MOV  [SAV_INT],BX
 MOV  [SAV_INT+2],ES
 push cs
 pop es
 MOV  AX,0251BH ;setze neuen Vektor
 MOV  DX,INT_1BH
 INT  021H      ;INT$21 Func$25: setze Interruptvektor
 mov ax,03524h  ;sichere alten Critical-Error-Vektor
 int 021h       ;lies Int.vektor
 mov [SAV_INT+4],bx
 mov [SAV_INT+6],es
 push cs
 pop es
 mov ax,02524h
 mov dx,INT_24H
 int 021h       ;setze Int.vektor

;+++ fr den Digitaloszi
 call O_SYSINIT ;alles fr Oszi initialisieren
 jnc o_st_ok    ;kein Fehler
 jmp BYE        ;z.B. Speicher reicht nicht, sofort Ende
o_st_ok:
;+++

;nur fr Basic
; MOV  SI,MSG1   ;Startmeldung ausgeben
; CALL PRTSTG
 mov  w[PRT_WAY],0 ;Ausgabe nur auf Bildschirm
 mov  w[PRT_SPC],1 ;Standardformat fr Zahlenausgabe

;+++ fr Oszi
 call O_HPRG  ;Oszihauptprogramm aufrufen
 jmp BYE      ;bei Rckkehr Ende


 call RUNINIT


 mov  si,080h ;zuerst wird die Kommandozeile des DOS
 cld          ;interpretiert, wenn sie > 2 Zeichen ist
 lodsb
 cmp  al,3
 jae  st100

;Dies ist die Hauptschleife. Sie sammelt die Eingaben und schreibt
;das Programm in den Speicher. Nach dem Einfgen, Ersetzen oder Lschen
;einer Zeile beginnt die Schleife von vorn. Die Schleife startet die
;Interpretation, wenn eine Zeile ohne Nummer gelesen wird.
;
;Eine Basic-Zeile im Speicher besteht aus:
;ein word (L/H) Zeilennummer
;ein byte Zeilenlnge (komplette Lnge in Byte)
;Text
;ein byte 0DH als Ende
;
;Das Programm beginnt bei TXTBGN. [TXTUNF] zeigt hinter
;das letzte Programmbyte. [TXTEND] ist das Ende des
;Programmspeichers.
;
;[CURRNT] zeigt auf den Anfang (die Zeilennummer) der gerade
;interpretierten Zeile. Im Direktmodus ist es grer als [TXTUNF].

RSTART:
 call RUNINIT
 MOV  SI,OK       ;'OK' ausgeben
 SUB  AL,AL
 CALL PRTSTG
st10:
;Eingabe einer Textzeile abwarten und ab [BUFFER] ablegen
;Ende-Zeichen ist $0d
 mov  si,[BUFFER]
 call GFSE_L
st100:
;bersetzung von [BUFFER] nach [BASBUF] : Textzeile in Token
;SI: Quelle
 call TSTNUM ;Zeilennummer ?
 mov  di,[BASBUF] ;DI: Ziel
 mov  [CURRNT],di ;fr Fehlermeldungen wichtig
 cld
 mov  ax,[FPR0+2] ;Z.nummer ablegen
 stosw
 cmp  ch,0   ;Zahlentyp der Z.nummer prfen
 jz   st103  ;keine Zahl (Integer 0 wird geliefert) ->ok
 cmp  ch,0afh
 jnz  st101  ;Typ mu Dezimal Integer sein
 or   dx,dx
 jz   st103  ;0-65535 erlaubt, 0 wie ohne Z.nummer
st101:
 mov  si,ZERRM ;ungltige Z.nummer
 call PRTSTG
 jmp  st10
st103:
 mov [TOK_LBY],di ;wichtig fr Test, ob Lngenbyte = 0 erlaubt ist
st104:
;jeweils einen Befehl und seine Daten bersetzen
 push di ;Adresse fr Lngenbyte und Platz
 inc di
st102:
 push di
 mov  di,TAB2
 call TFIND ;Token fr Befehl oder Zeilenende/Befehlstrenner finden
 pop  di
 stosb      ;Token aus AL speichern

;Info aus AH auswerten und so Parameter behandeln
st33:
 cmp ah,03h
 jnz st30

;$03: Zeilenende oder Befehlstrenner
st330:
 pop bx ;Adr. voriges Lngenbyte
 mov dx,di ;Lngenbyte ermitteln
 sub dx,bx
 dec dx
 dec dx
 mov [bx],dl ;und eintragen
 jnz st331   ;Lnge >0
 cmp [TOK_LBY],bx
 jnz st332   ;nicht erstes L.b., darf nie 0 sein
 cmp al,0dh  ;erstes L.b. darf auch nur 0 sein, wenn $0d folgt
 jnz st332
st331:
 cmp al,0dh ;Zeilenende ?
 jnz st104  ; nein
 jmp st18   ; ja
st332:
 mov di,bx  ;Lngenbyte =0, Fehlermeldung
 inc di     ;di auf sinnvolles korrigieren
 mov al,0a3h ;das unsichtbare LET-Token, da eins stehen mu
 stosb
 mov bl,137
 jmp sterror

st30:
 cmp  ah,02h
 jnz  st31

;$02: Befehl ohne Parameter
 push di ;nchstes Element tokenisieren
 mov di,TAB3
 call TFIND
 pop di
 mov bl,150 ;mit Fehlercode laden
 cmp ah,03h ;ein Befehls-/Zeilenende ?
 jnz sterror ; nein, ERROR 150: Parameter hinter parameterlosem Befehl
 stosb       ; ja, speichern
 jmp st330
sterror:
 mov  al,0dh
 stosb
 jmp  NERROR

st31:
 cmp  ah,01h
 jnz  st32

;$01: alles bis zum Zeilenende unverndert bernehmen
st310:
 lodsb
 cmp al,' ' ;auer das erste fhrende Space
 jnz st312
st311:
 lodsb
st312:
 stosb
 cmp al,0dh
 jnz st311
 jmp st330

st32:
 cmp  ah,00h

;$00: Parameter bis : oder Zeilenende wandeln
st320:
 push di
 mov di,TAB3 ;Syntaxelemente eines Ausdruckes
 call TFIND  ;in Tabelle suchen
 pop  di
 or   al,al
 jz   st324 ;in Tabelle nichts gefunden
 stosb      ;Token ablegen
 cmp ah,01h ;String ablegen ?
 jz st323   ; ja
 cmp ah,03h ;ist es ein Befehls-/Zeilenende ?
 jnz st320  ; nein
 jmp st330  ; ja
st324:
 call TSTNUM   ;eine Zahl ?
 or   ch,ch
 jz   st325    ;keine Zahl
 mov  al,ch
 stosb         ;Zahl-Token
 cmp  al,0adh  ;Float ?
 jz   st326
 mov  ax,[FPR0+2] ;32 Bit Zahl
 stosw
 mov  ax,[FPR0+4] ;lowest Byte zuerst
 stosw
 jmp  st320
st326:
 mov  dx,si
 mov  si,FPR0 ;Float-Zahl
 movs4w
 mov  si,dx
 jmp  st320
st325:
 call VFIND ;eine Variable ?
 jnc st005  ; ja
 mov bl,137 ; nein, Syntaxerror
 jmp sterror
st005:
 stosw       ;Variable-Token, -Nummer
 jmp st320
st323:
;konstanten String ablegen
 mov bx,di   ;hierher kommt das Lngenbyte
 inc di
st11:
 lodsb
 cmp  al,0dh
 jnz  st16
 mov  di,bx    ;String killen
 dec  di
 mov  bl,134
 jmp  sterror  ;Error 134, " fehlen
st16:
 cmp  al,022h
 jz   st17
 stosb
 jmp  st11
st17:
 mov  ax,di
 sub  ax,bx
 dec  ax
 mov  [bx],al  ;String-Lngenbyte eintragen
 jmp  st320

st18:
;Zeile ist fertig bersetzt
 mov si,[BASBUF] ;SI: Beginn des Zeilentextes
 mov cx,di       ;CX: Zeiger hinter Ende
 mov ax,di
 sub ax,si       ;Lnge der Zeile
 mov bx,[si]     ;BX: Zeilennummer
 or bx,bx
 jnz  ST3B       ;Zeile frs Programm
 cmp  al,04h
 jz   st20       ;nur RETURN-Taste
 call RUNINIT    ;Zeile im Direktmodus interpretieren
 mov  si,[BASBUF]
 mov  [CURRNT],si
 add  si,zuetb
 jmp  TEXEC
st20:
 jmp  RSTART

ST3B:
 PUSH CX
 push si      ;SI: Beginn, CX: hinter Ende
 MOV  AX,CX
 sub  ax,si
 PUSH AX      ;AX: Zeilenlnge in Bytes (inclusive Binrword)
 CALL FNDLN   ;suche Zeile im Programm
 push si      ;zeigt auf Zeile im Programm / hinter Programmende
 jc   st4
 JNZ  ST4     ;C oder NZ: nicht gefunden, bei SI einfgen
 push si      ;Z: gefunden, also lschen
 CALL FNDNXT  ;suche nchste Zeile (BX ist ja noch gltig)
 pop  di      ;DI: erstes zu lschendes, SI: erstes nicht zu lschendes
 cld          ;increment
 mov  cx,[TXTUNF] ;CX: hinter Programmende
 sub  cx,si       ;Anzahl Byte (auch 0 geht bei REP)
 rep movsb        ;Zeile lschen
 MOV  [TXTUNF],di ;neues Programmende
ST4:
 POP  CX   ;CX: Einfgepunkt
 POP  AX   ;AX: Lnge Eingabezeile
 pop  dx   ;DX: Anfang Eingabezeile
 cmp  al,zuetb+1 ;enthlt die Zeile nur $0D ?
 jnz  ST6  ; nein, mehr
 jmp  st10 ; ja, nichts einfgen, neue Eingabe erwarten
ST6:
 mov  si,[TXTUNF] ;SI: hinter altes Programmende
 mov  di,ax       ;AX: Lnge Eingabezeile
 add  di,si       ;DI: hinter neues Programmende
 mov  [TXTUNF],di ;neues P.ende
 cmp  di,[TXTEND] ;ist noch Platz fr die Programmzeile ?
 jb   ST4B
 MOV  BL,128
 JMP  NERROR ; nein
ST4B:
 mov  bx,cx  ;BX: Einfgepunkt
 mov  cx,si
 sub  cx,bx  ;CX: Anzahl Bytes zu verschieben
 dec  si     ;Quelle: auf altes P.ende
 dec  di     ;Ziel: auf neues P.ende
 std         ;decrement
 rep movsb   ;Platz freimachen
 mov  si,dx  ;Quelle: Anfang der Eingabezeile
 mov  di,bx  ;Ziel: Einfgepunkt
 mov  cx,ax  ;Anzahl Bytes zu verschieben
 cld         ;increment
 rep movsb   ;Zeile einsetzen
 jmp  st10   ;und auf nchste Eingabe warten


VFIND:
;teste, ob SI in Quellzeile auf eine Variable zeigt
;in:  SI: Textzeiger
;out: SI: Textzeiger dahinter
;     AL: Variablentoken ($A8-$AB), spter $A6-$AB
;     AH: Variablennummer
;     Flags: C=keine_Variable,  NC=ok
;fre: DI
 mov ah,'@'
 call IGNBLNK
 jc ret     ;Flag C fr Fehler
 jnz vfind0 ;kein @ Array
 mov ax,000a9h
 clc
 ret

vfind0:
 cld             ;SI und DI auf Increment
 mov  bx,di
 MOV  DI,PRO_REG ;Vergleichstabelle
 MOV  CX,regvars ;Anzahl der Registervariablen
 LODSW           ;Variablennamen aus Text holen
 cmp  al,'a'     ;Umwandlung Kleinbuchstaben->Groe
 jc   vfind3
 cmp  al,'z'
 ja   vfind3
 sub  al,020h
vfind3:
 cmp  ah,'a'     ;Umwandlung Kleinbuchstaben->Groe
 jc   vfind31
 cmp  ah,'z'
 ja   vfind31
 sub  ah,020h
vfind31:
 REPNZ SCASW     ;2 Byte ASCII als word vergleichen
 xchg di,bx
 jnz  vfind4     ;keine Registervariable
 sub  bx,PRO_REG+2
 shl  bl,1
 mov  al,0aah    ;Token fr Registervar. $AA
 mov  ah,bl      ;Nummer 0,4,8,... (derzeit 32Bit Var.)
 clc
 ret

vfind4:
 DEC  SI       ;korrigieren
 DEC  SI
 CMP  AL,'Z'+1 ;Variablen A-Z ?
 CMC           ;negiere C-Flag
 JC   RET      ;keine Variable
 SUB  AL,'A'
 JC   RET      ;keine Variable
 cmp ah,'#' ;Float-Variable ?
 jz vfind5  ; ja
 inc  si
 add  al,al
 add  al,al
 mov  ah,al    ; nein, Integer, Nummer 0,4,8,...
 mov  al,0abh  ;Token fr 32 Bit Variable $AB
 clc
 ret

vfind5:
 cmp al,08h ;nur A# bis H#, also 8 Variablen
 cmc
 jc ret ;zu grer als H#
 inc si
 inc si
 mov cl,3
 shl al,cl ;*8 Byte
 mov ah,al   ;Float, Nummer 0,8,16,...
 mov al,0a8h ;Token fr Float-Var. $A8
 clc
 ret


VDECO:
;liste eine Variable aus Programm
;in:  AL: Var.token
;     SI: zeigt auf Var.nummer
;out: SI: -"- hinter
 mov  ah,al
 cld
 lodsb
 cmp  ah,0a9h
 jnz  vdeco1
 mov  al,'@'  ;Feld, derzeit nur @ ************
 call CHROUT
 ret
vdeco1:
 cmp  ah,0abh
 jnz  vdeco2
 shr  al,1    ;normale 32Bit Var.
 shr  al,1
 add  al,'A'
vdeco0:
 call CHROUT
 ret
vdeco2:
 cmp  ah,0aah
 jnz  vdeco3
 shr  al,1    ;Registervariable
 mov  ah,0
 mov  di,PRO_REG
 add  di,ax
 mov  al,[di]
 call CHROUT
 mov  al,[di+1]
 jmp  vdeco0
vdeco3:
 cmp  ah,0a8h
 jnz  vdeco5
 shr  al,1   ;normale Float-Var.
 shr  al,1
 shr  al,1
 add  al,'A'
 call CHROUT
 mov  al,'#'
 call CHROUT
 ret
vdeco5:
 ret


VRGETV:
;holt den Wert der Register-Variablen
;Routine steht in TAB3A
;in:  SI: Zeiger auf Nummer im Programm
;     DI: Zeiger auf Ergebnisplatz
;out: SI: -"- hinter
;     [DI]: Wert, DI unverndert
 cld
 lodsb
 clr  ah
 add  ax,[VARREG]
 jmp  vlgetv0


VLGETV:
;holt den Wert der 32 Bit Variablen, sonst wie VRGETV
 cld
 lodsb
 clr  ah
 add  ax,[VARBGN]
vlgetv0:
 mov  bx,si
 mov  si,ax
 mov  cx,di
 clr  ax
 stosw       ;Integer
 movsw
 movsw
 mov  di,cx
 mov  si,bx
 ret


VAGETV:
;wie VRGETV, aber fr Feldvar.
 cld
 lodsb
 ;derzeit noch keine Nummernauswertung
 push di
 call IPARN
 pop  di
 mov  ax,bx
 add  ax,ax
 jc   vagetv0
 add  ax,ax
 jc   vagetv0
 add  ax,ax
 jc   vagetv0 ;Index zu gro
 neg  ax      ;+ Zweierkomplement statt -
 add  ax,[VARFLD] ;Variablenadresse
 cmp  [TXTUNF],ax ;wrde Text berschrieben ?
 jnc  vagetv0     ; ja
 jmp  vfgetv0     ; nein
vagetv0:
 mov  bl,130 ;Index zu gro
 jmp  NERROR


VFGETV:
;holt den Wert der normalen Float-Variablen
;wie VRGETV
 cld
 lodsb
 clr  ah
 add  ax,[VARFPT]
vfgetv0:
 mov  dx,si
 mov  si,ax
 mov  cx,di
 movs4w
 mov  di,cx
 mov  si,dx
 ret


bmissequ:
 mov  bl,147 ;Gleichheitszeichen fehlt:
 jmp  NERROR ;meist unbekannter Befehl


SETVAL:
;variable=expr  setzt die Variable auf
;den Wert von expr
;in:  SI: Textzeiger auf Variablentoken
;out: SI: -"- hinter expr
;     AL,DI: Var.typ und Adr.
 call VGETIA
 push ax
 push di
 cld
 lodsb
 cmp  al,0a5h ; = ?
 jnz  bmissequ
 mov  di,FPR0
 call EXP
 pop  di
 pop  ax

VSETV:
;setzt den Wert in die Variable
;in:  AL: Variablentyp
;     DI: Var.adr.
;     FPR0: Wert
;out: AX, DI unverndert
 cmp  al,4
 jae  vsetv4 ;4 und 5 ->Float und String
 push di     ;32, 16, 8 Bit Int
 mov  di,FPR0
 call CFPIN  ;Integer mu es sein
 pop  di
 cmp  al,2   ;AX blieb erhalten
 jb   vsetv1
 jz   vsetv2
 mov  [di],bl ;3 ->8 Bit
 ret
vsetv1:
 mov  [di+2],dx ;1 ->32 Bit
vsetv2:
 mov  [di],bx   ;2 ->16 Bit
 ret
vsetv4:
 ja   vsetv5
 mov  bp,di   ;Floatvar.
 mov  di,FPR0 ;Wandlung in Float
 call CINFP
 mov  dx,si
 mov  si,di
 mov  di,bp
 cld
 movs4w
 mov  di,bp
 mov  si,dx
 ret
vsetv5:
;********************String
 ret


VGETIA:
;ermittelt aus Programm die Var.adresse und den Typ
;in:  SI: Textzeiger auf Var.token
;out: SI: -"- hinter (evtl. Index wird ausgewertet)
;     AL: Var.typ: 1=32Bit_Int., 2=16Bit_Int., 3=8Bit_Int.,
;         4=Floating_Point(64Bit), 5=String
;     DI: Adresse
 cld
 lodsw         ;Var.token und Nummer
 cmp  al,0abh
 jnz  vgetia2
 mov  di,[VARBGN] ;normale 32 Bit Int. Var.
 mov  al,ah
 mov  ah,0
 add  di,ax
 mov  al,1
 ret
vgetia2:
 cmp  al,0aah
 jnz  vgetia3
 mov  di,[VARREG] ;32 Bit Int. Registervar.
 mov  al,ah
 mov  ah,0
 add  di,ax
 mov  al,1
 ret
vgetia3:
 cmp  al,0a9h
 jnz  vgetia4
 ;******* derzeit nur das @-Feld, noch keine Nummernauswertung
 call IPARN     ;Index ermitteln
 mov  di,bx
 add  di,di
 jc   vgetia30
 add  di,di
 jc   vgetia30
 add  di,di
 JC   vgetia30 ;Index zu gro
 neg  di       ;+ Zweierkomplement statt -
 add  di,[VARFLD] ;Variablenadresse
 cmp  [TXTUNF],di ;wrde Text berschrieben ?
 jnc  vgetia30    ; ja
 mov  al,4        ;Float-Var.
 ret
vgetia30:
 mov  bl,130 ;Index zu gro
 jmp  NERROR
vgetia4:
 cmp  al,0a8h
 jnz  vgetia5
 mov  di,[VARFPT] ;Float-Var.
 mov  al,ah
 mov  ah,0
 add  di,ax
 mov  al,4
 ret
vgetia5:
 ;******* hier spter weitere Typen einfgen
 mov  bl,145   ;Fehler: Variable fehlt
 jmp  NERROR


IKGETV:
;holt den Wert der Integerkonstanten aus Programm nach [DI]
;Routine steht in TAB3A
 clr  ax
 cld
 mov  cx,di
 stosw
 movsw
 movsw
 mov  di,cx
 ret


FKGETV:
;holt den Wert der Floatkonstanten aus Programm nach [DI]
;Routine steht in TAB3A
 cld
 mov  cx,di
 movs4w
 mov  di,cx
 ret


CFPIN:
;konvertiert die Zahl bei [DI] in Integer falls sie
;es nicht schon ist
;in:   [DI]: Float oder Int
;out:  [DI]: Int
;      DXBX: Kopie des Integers
;fre: AX, BP, SI
 test b[di+1],080h
 jnz  cfpin6
 mov  bx,[di+2] ;ist schon Integer
 mov  dx,[di+4]
 ret
cfpin6:
 push bp
 clr  bx
 clr  dx
 mov  cx,[di]
 and  ch,03fh
 sub  cx,02000h
 jbe  cfpin4 ;Int =0
 cmp  cx,5
 jb   cfpin1
 ja   cfpin5
 cmp  b[di+7],022h ;wenn 9/10 Stellen, nur bis 2199999999
 jae  cfpin5
cfpin1:
 shl  cx,1
cfpin2:
 push cx
 shl  bx,1 ;DXBX = DXBX*10
 rcl  dx,1
 mov  bp,bx
 mov  cx,dx
 shl  bx,1
 rcl  dx,1
 shl  bx,1
 rcl  dx,1
 add  bx,bp
 adc  dx,cx
 mov  cx,4
 clr  bp
cfpin3:
 shl  w[di+2],1
 rcl  w[di+4],1
 rcl  w[di+6],1
 rcl  bp,1
 loop cfpin3
 add  bx,bp
 adc  dx,0
 pop  cx
 loop cfpin2
 or   dx,dx  ;berlauf setzt, da nicht viel grer,
 js   cfpin5 ;immer Bit31 =1 im Integer
cfpin0:
 test b[di+1],040h ;Vorzeichen auswerten
 jz   cfpin4
 not  bx     ;negative Zahl
 not  dx
 clr  bp
 add  bx,1
 adc  dx,bp
cfpin4:
 mov  [di+2],bx
 mov  [di+4],dx
 mov  [di],bp
 pop  bp
 ret
cfpin5:
 mov  bx,[VARREG] ;berlauf bei Konvertierung
 or   b[bx+44],8  ;Bit3 in ER =1
 mov  bx,0ffffh
 mov  dx,07fffh
 jmp  cfpin0


CINFP:
;konvertiert die Zahl bei [DI] in Float, falls sie
;es noch nicht ist
;in:  [DI]: Int oder Float
;out: [DI]: Float
;fre: AX, BP, SI
 test b[di+1],080h
 jnz  ret          ;schon Float
 push ax
 push bp
 mov  bx,[di+2]
 mov  dx,[di+4]
 mov  w[di],08000h ;Float =0
 clr  ax
 mov  [di+2],ax
 mov  [di+4],ax
 mov  [di+6],ax
 mov  ax,bx
 or   ax,dx
 jz   cinfp1       ;Zahl bleibt =0
 mov  b[di+1],0a0h ;Float <>0, *100^0, +
 or   dx,dx
 jns  cinfp2 ;Zahl >0
 mov  b[di+1],0e0h ;Float <>0, *100^0, -
 not  bx
 not  dx
 add  bx,1
 adc  dx,0
cinfp2:
;Vorzeichenlose 32 Bit Division
;DXBX = DXBX / 100 ,  BPAX = Rest
 clr  ax
 clr  bp
 mov  cx,32  ;Anzahl der Bits
cinfp3:
 shl  bx,1
 rcl  dx,1
 rcl  ax,1
 rcl  bp,1
 sub  ax,100
 sbb  bp,0
 jc   cinfp4
 or   bl,1
 loop cinfp3
 jmp  cinfp5
cinfp4:
 add  ax,100
 adc  bp,0
 loop cinfp3
cinfp5:
 aam        ;Konvertierung dual -> BCD ungepackt in AX
 mov  cl,4
 shl  ah,cl ;Zehner ins Highnibble
 or   al,ah ;BCD gepackt in AL
 mov  cx,[di+4] ;um 2 Stellen rechts schieben
 mov  [di+3],cx
 mov  cx,[di+6]
 mov  [di+5],cx
 mov  [di+7],al ;neuen 100er Einfgen
 inc  w[di]     ;Exp erhhen
 mov  ax,bx
 or   ax,dx
 jnz  cinfp2    ;noch nicht alles fertig
cinfp1:
 pop  bp
 pop  ax
 ret


TSTNUM:
;teste ob der Text eine Zahl ist, wenn ja wandle ihn
;in:  SI: Textzeiger
;out: SI:  -"- hinter Zahl
;     FPR0: gewandelte Zahl
;     CH: 0=keine_Zahl,  $ad=float,  $ae=hex.int.,  $af=dez.int.
;fre: DI
 clr  bx      ;DXBX=0
 clr  dx
 clr  cx
 mov  ah,'$'  ;Hexzahl ?
 call IGNBLNK ;Spaces berlesen, erledigt auch cld
 jnz  tnumd0
;Hexzahl wandeln
tnumh2:
 lodsb
 call TSTZIF ;Ziffer 0 bis 9 ?
 jnc  tnumh1 ; ja
 call CCBIG  ;in Grobuchstaben
 cmp  al,'A'
 jb   tnumh4 ;zu klein
 cmp  al,'F'
 ja   tnumh4 ;zu gro
 sub  al,'A'-10 ;'A' bis 'F' nach $A bis $F
tnumh1:
 mov  cx,4
tnumh5:
 sal  bx,1
 rcl  dx,1
 loop tnumh5
 or   bl,al
 jmp  tnumh2
tnumh4:
 dec  si
 mov  ch,0aeh   ;es war eine Hexzahl
tnumh6:
 mov  w[FPR0],0 ;Integer, auch fr Dezimal
 mov  w[FPR0+2],bx
 mov  w[FPR0+4],dx
 ret

tnumd0:
;Dezimalzahl wandeln
 push di
 mov  ch,020h ;Bit6=Sign +,  Bit5=1=keine_Zahl
 mov  ah,'-'  ;negatives Vorzeichen ?
 call IGNBLNK
 jnz  tnumd00
 mov  ch,060h ;Sign -
tnumd00:
 mov  bp,FPR0 ;als Zwischen- und Ergebnisspeicher
 mov  di,bp
 mov  ax,cx
 stosw        ;Sign und Kennung
 clr  ax      ;Rest auf 0 setzen
 stosw
 stosw
 stosw
 clr  cx      ;CL: Zhler fr Gesamt., CH: Zhler fr Nachkommastellen
tnumd1:
 lodsb
 call TSTZIF  ;teste ob / wandle Ziffer
 jc   tnumd2  ; nein
 and  b[bp+1],0dfh ;Kennung auf Zahl (Int/Float)
 mov  ah,cl
 or   ah,al
 jz   tnumd1  ;fhrende 0en berlesen
 inc  cl      ;Vorkommastellen
 cmp  cl,12
 ja   tnumd1  ;nur 12 Stellen, danach nur fr Exponenten zhlen
 call tnumui  ;Sammlung als BCD-Kode in w[BP+6]w[BP+4]w[BP+2]
 cmp  cl,9
 jbe  tnumd1  ;Integer nur bis 9 Stellen, danach
 or   b[bp+1],080h ;Kennung auf Float
 jmp  tnumd1
tnumd2:
 cmp  al,'.'
 jz   tnumf0 ;Dezimalpunkt
 dec  si     ;auf erstes ungltiges Zeichen
 test b[bp+1],020h
 jz   tnumd3
;keine Zahl: Integerwert 0 und CH =0 =keine_Zahl
 clr  bx
 clr  dx
 clr  cx
 jmp  tnumd9
tnumd3:
 call tnume  ;Exponent ?
 jnc  tnumf3 ; ja
 test b[bp+1],080h ;teste ob Int, da weder . noch Exp. folgt
 jz   tnumd4  ;Int bis 9 Stellen
 jmp  tnumf3  ;zuviel fr Int
tnumd4:
;wandle die BCD-Zahl in binr Int
 clr  bx
 clr  dx
 mov  ch,10 ;10 BCD-Stellen
tnumd5:
 mov  cl,9
 mov  ax,bx
 mov  di,dx
tnumd6:
 add  bx,ax ;DXBX=DXBX*10
 adc  dx,di
 dec  cl
 jnz  tnumd6
 mov  cl,4
 clr  ax
tnumd7:
 shl  w[bp+2],1 ;1 Digit holen
 rcl  w[bp+4],1
 rcl  b[bp+6],1
 rcl  ax,1
 dec  cl
 jnz  tnumd7
 add  bx,ax   ;dazuaddieren
 adc  dx,0
 dec  ch
 jnz  tnumd5  ;alle 10 Digits
 test b[bp+1],040h ;Sign - ?
 jz   tnumd8  ; nein
 negdxbx      ;DXBX=-DXBX
tnumd8:
 mov  ch,0afh ;Dezimal Int
tnumd9:
 pop  di
 jmp  tnumh6

tnumf0:
;Dezimalpunkt gefunden, Zahl mit Nachkommaziffern
;auf max. 12 Stellen fllen und folgende Ziffern berlesen
 lodsb
 call TSTZIF
 jc   tnumf01
 mov  bl,cl
 or   bl,al   ;wenn noch keine Vorkommastellen,
 jnz  tnumf02 ;dann fhrende Nachkommanullen nur zhlen
 inc  ch      ;Nachkommastellen
 jmp  tnumf0
tnumf02:
 cmp  cl,12
 ja   tnumf0  ;Zahl voll, Rest berlesen
 inc  cl      ;BCD-Stellen
 inc  ch      ;Nachkommastellen
 call tnumui  ;Ziffer anfgen
 jmp  tnumf0
tnumf01:
 dec  si
 call tnume   ;Exponent? wenn ja, auswerten

tnumf3:
;10er Exponent in BX (16 Bit signed), CH Nachkomma, CL BCD-Stellen
 test b[bp+7],0f0h
 jnz  tnumf30 ;erste Ziffer <>0 ins hchste BCD-Nibble,
 cmp  cl,12   ;also Anzahl der BCD-Stellen auf 12 bringen
 jae  tnumf34 ;12 erreicht, trotzdem noch 0 vorn --> alles ist 0
 clr  al
 call tnumui
 inc  cl
 inc  ch
 jmp  tnumf3
tnumf34:
 mov  bx,08000h ;0 wird durch alles 0 (auer Kennbit) dargestellt
 clr  ax
 mov  [bp+2],ax ;nullsetzen, da hierhin auch bei Exponent
 mov  [bp+4],ax ;zu gro oder zu klein gesprungen wird
 mov  [bp+6],ax
 jmp  tnumf33
tnumf30:
 clr  ah
 mov  al,cl ;BCD-Stellen im Sammler
 mov  cl,ch ;Anzahl Nachkommastellen
 clr  ch
 sub  ax,cx ;kann auch negativ werden, z.B. bei 0.0001
 add  bx,ax ;10er Exp korrigieren
 sar  bx,1  ;10er -> 100er Exp
 jnc  tnumf31 ;ok, da 10er vielfaches des 100er war
 inc  bx    ;sonst 100er +1 und Zahl um 1 Stelle nach rechts
 mov  cx,4
tnumf32:
 shr  w[bp+6],1
 rcr  w[bp+4],1
 rcr  w[bp+2],1
 loop tnumf32
tnumf31:
 add  bx,02000h ;Exp addiert zu $2000, Bit15-14 =0
 cmp  bx,02000h+5000 ;prfe, ob Exp zu gro/klein
 ja   tnumf34
 cmp  bx,02000h-4998
 jb   tnumf34
 or   bh,080h ;Float-Kennung
 mov  al,040h
 and  al,[bp+1]
 or   bh,al   ;Vorzeichen
tnumf33:
 mov  [bp],bx
 mov  ch,0adh ;Float
 pop  di
 ret

tnumui:
;Ziffer aus Bit3-0 von AL an BCD-Kette anhngen
 push cx
 mov  cx,4    ;nach links schieben und Ziffer einfgen
tnumui0:
 shl  w[bp+2],1
 rcl  w[bp+4],1
 rcl  w[bp+6],1
 loop tnumui0
 or   b[bp+2],al
 pop  cx
 ret

tnume:
;teste ob SI auf einen gltigen Exponenten zeigt
;gltig: Ez, E+z, E-z, ez, e+z, e-z  (z: mind. 1 Dezimalziffer)
;wenn ja, wandle ihn nach BX und lsche C-Flag
;sonst setze C-Flag
;SI zeigt auf erstes unverstndliches Zeichen falls Exp gltig
;sonst SI nicht verndert
;fre: CX, nicht verndert: BP
 push cx     ;sichern
 mov  dx,si  ;sichern fr ungltig
 mov  b[bp],0 ;Exp. positiv
 clr  bx     ;Exp. =0
 mov  cx,4   ;maximal 4 Stellen Exponent
 lodsb
 cmp  al,'e'
 jz   tnume1
 cmp  al,'E'
 jz   tnume1
tnume5:
 pop  cx
 mov  si,dx  ;kein gltiger Exp.
 stc
 ret
tnume1:
 lodsb
 cmp  al,'+'
 jz   tnume2
 cmp  al,'-'
 jnz  tnume3
 mov  b[bp],0ffh ;Exp. negativ
tnume2:
 lodsb
tnume3:
 call TSTZIF
 jc   tnume5
 jmp  tnume4 ;eine Ziffer gltig -> Exp. gltig, dx wieder frei
tnume6:
 lodsb
 call TSTZIF
 jc   tnume7
tnume4:
 clr  ah     ;Ziffer zum Exponenten
 mov  di,ax
 mov  ax,10
 mul  bx     ;DXAX=AX*BX
 mov  bx,ax
 add  bx,di
 loop tnume6 ;alle max. 4 Stellen
 inc  si     ;ist wichtig (mu hinter ausgewertetes zeigen)
tnume7:
 dec  si ;auf nicht ausgewertetes
 test b[bp],0ffh
 jz   tnume8 ;Exp. positiv
 neg  bx     ;BX=-BX
tnume8:
 pop  cx
 clc
 ret


TSTZIF:
;wenn AL = '0' bis '9' dann AL = 0 bis 9, Flag NC
;sonst AL unverndert, Flag C
 cmp  al,'0'
 jc   ret
 cmp  al,'9'+1
 cmc
 jc   ret
 sub  al,'0' ;lscht C-Flag
 ret


INT_1BH:
;wird beim Drcken von Fn und B aufgerufen:
;setzt Flag fr Programmabbruch
 CS: MOV  B[PRG_BRK],0FFH
 IRET


INT_24H:
;wird vom DOS bei Fehlern aufgerufen, erzeugt normalerweise
;diese "Abbruch, Fehler, Ignorieren"-Meldung
;jetzt werden alle Fehler sofort als "Fehler" weitergegeben
 sti      ;das Swift-Basic lt hier noch einen Piep los
 xor al,al
 iret


OK:    DB 'OK',0DH
ERMSG: DB 'ERROR ',0
ZERRM: db 'ERROR 152',0dh

;Syntaxtabellen:
;jeder Tabelleneintrag besteht aus einem Byte, in dem die Lnge+1
;des Befehlswortes steht, gefolgt von dem Befehlswort.
;Das Tabellenende ist durch 01H und ein nachfolgendes word gekennzeichnet,
;das geliefert wird, falls kein anderer Eintrag zutraf.

;Basic-Befehle, Token ab $80, freies Token: 0ach
;Info im Highbyte: Bit7-6 wird von TDECO ausgewertet
; Bit7=1 liste ein Space davor
; Bit6=1 liste ein Space danach
;Bit 5-0 wird beim Tokenisieren ausgewertet
; =0 Befehl hat eventuell Parameter
; =1 Zeilenrest bis auf das evtl. erste Space unverndert bernehmen
; =2 Befehl darf keine Parameter haben
; =3 Zeilenendezeichen oder Befehlstrenner
TAB2:
 DB 2,0dh  ;Zeilenendezeichen
 DW 0030dh ;liefert wieder $0d
 DB 2,'?'
 DW 04080h
 DB 7,'AKTREG'
 DW 04281h
 DB 4,'BYE'
 DW 04282h
 DB 6,'COLOR'
 DW 04083h
 DB 5,'CALL'
 DW 04084h
 DB 5,'CLIP'
 DW 04085h
 DB 5,'DATA'
 DW 041a6h
 DB 4,'DEG'
 DW 042abh
 DB 7,'DRAWTO'
 DW 04086h
 DB 4,'END'
 DW 04287h
 DB 5,'EXIT'
 DW 04088h
 DB 4,'FOR'
 DW 04089h
 DB 5,'GOTO'
 DW 0408ah
 DB 6,'GOSUB'
 DW 0408bh
 DB 9,'GRAPHICS'
 DW 0408ch
 DB 6,'INPUT'
 DW 0408dh
 DB 3,'IF'
 DW 0408eh
 DB 4,'INT'
 DW 0408fh
 DB 5,'LIST'
 DW 04090h
 DB 5,'LOAD'
 DW 04091h
 DB 4,'LET'
 DW 04092h
 DB 6,'LPOKE'
 DW 040a9h
 DB 5,'NEXT'
 DW 04093h
 DB 4,'NEW'
 DW 04294h
 DB 4,'OUT'
 DW 04095h
 DB 5,'PLOT'
 DW 04096h
 DB 6,'PMODE'
 DW 040a4h
 DB 9,'POSITION'
 DW 04097h
 DB 5,'POKE'
 DW 04098h
 DB 6,'PRINT'
 DW 04099h
 DB 4,'RAD'
 DW 042aah
 DB 7,'RETURN'
 DW 0429ah
 DB 5,'READ'
 DW 040a7h
 DB 4,'REM'
 DW 0419bh
 DB 7,'REPEAT'
 DW 0429ch
 DB 8,'RESTORE'
 DW 040a5h
 DB 4,'RUN'
 DW 0429dh
 DB 6,'SOUND'
 DW 0409eh
 DB 5,'SAVE'
 DW 0409fh
 DB 6,'TMODE'
 DW 040a0h
 DB 6,'UNTIL'
 DW 040a1h
 DB 6,'USING'
 DW 040a8h
 DB 6,'WPOKE'
 DW 040a2h
 DB 1     ;Tabellenende
 DW 00a3h ;Wertzuweisung ohne LET

TAB2A:
 DW PRINT
 DW AKTREG
 DW BYE
 DW COLOR
 DW BCALL
 DW BCLIP
 DW DRAWTO
 DW BEND
 DW BEXIT
 DW FOR
 DW GOTO
 DW GOSUB
 DW GRAPHICS
 DW INPUT
 DW IFF
 DW BINT
 DW LIST
 DW DLOAD
 DW LET
 DW NEXT
 DW NEW
 DW OUTCMD
 DW BPLOT
 DW POSITION
 DW POKE
 DW PRINT
 DW RETURN
 DW REM
 DW BREPEAT
 DW RUN
 DW BSOUND
 DW DSAVE
 DW BTMODE
 DW BUNTIL
 DW WPOKE
 DW DEFLT ;Wertzuweisung ohne LET
 DW BPMODE
 DW BRESTORE
 DW BDATA
 DW BREAD
 DW BUSING
 DW LPOKE
 DW BRAD
 DW BDEG

TAB3:
;Funktionen, Operatoren, Variablen, Konstanten,
;Trennzeichen,...
;Info im Highbyte: Bit7-6 wird von TDECO ausgewertet
; Bit7=1 liste ein Space davor
; Bit6=1 liste ein Space danach
 db 2,0dh ;Zeilenende, liefert wieder $0d
 dw 030dh
 db 2,':' ;Befehlstrenner, liefert $0e
 dw 030eh
 db 2,'+'
 dw 0080h
 db 2,'-'
 dw 0081h
 db 2,'*'
 dw 0082h
 db 2,'/'
 dw 0083h
 db 4,'NOT'
 dw 04084h
 db 4,'AND'
 dw 0c085h
 db 3,'OR'
 dw 0c086h
 db 4,'SHL'
 dw 0c087h
 db 4,'SHR'
 dw 0c088h
 db 4,'MOD'
 dw 0c089h
 db 4,'XOR'
 dw 0c08ah
 db 2,'^'
 dw 008bh
 db 2,'\'
 dw 008ch ;erstmal fr CHR$ bei PRINT
 db 3,'>='
 dw 00a0h
 db 3,'<='
 dw 00a1h
 db 3,'<>'
 dw 00a2h
 db 2,'>'
 dw 00a3h
 db 2,'<'
 dw 00a4h
 db 2,'='
 dw 00a5h
 db 2,'('
 dw 0090h
 db 2,')'
 dw 0091h
 db 2,','
 dw 0092h
 db 3,'TO'
 dw 0c093h
 db 5,'STEP'
 dw 0c094h
 db 2,';'
 dw 0095h
 db 2,022h ;" als Stringkonstantenbeginn
 dw 01ach
 DB 4,'RND'
 dw 00b0h
 DB 4,'INP'
 dw 00b1h
 DB 5,'PEEK'
 dw 00b2h
 DB 6,'WPEEK'
 dw 00b3h
 DB 4,'ABS'
 dw 00b4h
 DB 4,'FRE'
 dw 00b5h
 DB 5,'CINT'
 dw 00b6h
 DB 4,'HIB'
 dw 00b7h
 DB 5,'CDBL'
 dw 00b8h
 DB 6,'POINT'
 dw 00b9h
 DB 5,'GKEY'
 dw 00bah
 DB 5,'TKEY'
 dw 00bbh
 DB 3,'LN'
 dw 00bch
 DB 6,'LPEEK'
 dw 00bdh
 DB 5,'FILE'
 dw 00beh
 DB 4,'GET'
 dw 00bfh
 DB 4,'PUT'
 dw 00c0h
 DB 4,'BIT'
 dw 00c1h
 DB 4,'SQR'
 dw 00c2h
 DB 4,'FIX'
 dw 00c3h
 DB 5,'FRAC'
 dw 00c4h
 db 3,'LG'
 dw 00c5h
 db 6,'EXP10'
 dw 00c6h
 db 4,'EXP'
 dw 00c7h
 db 4,'SIN'
 dw 00c8h
 db 4,'COS'
 dw 00c9h
 db 4,'TAN'
 dw 00cah
 db 3,'PI'
 dw 00cbh
 db 1
 dw 0000h ;Token $00 fr nichts gefunden

TAB3A:
;Sprungadressen fr Ausdruckstoken $A0-$FF
 DW XP11 ;>=
 DW XP14 ;<=
 DW XP12 ;<>
 DW XP13 ;>
 DW XP16 ;<
 DW XP15 ;=
 DW dummyf
 DW dummyf
 DW VFGETV ;normale Float Var.
 DW VAGETV ;Feldvar.
 DW VRGETV ;Registervariable
 DW VLGETV ;normale 32 Bit Var.
 DW dummyf ;Stringkonstante
 DW FKGETV ;Float-Konstante
 DW IKGETV ;Hex-Integer-K.
 DW IKGETV ;Dez-Integer-K.
 DW RND
 DW INP
 DW PEEK
 DW WPEEK
 DW BABS
 DW BFRE
 DW BCINT
 DW BHIB
 DW BCDBL
 DW BPOINT
 DW BGKEY
 DW BTKEY
 DW BLOGN
 DW LPEEK
 DW BFILE
 DW BGET
 DW BPUT
 DW BBIT
 DW BSQR
 dw BFIX
 dw BFRAC
 dw BLOGG
 dw BEXPG
 dw BEXPN
 dw BSIN
 dw BCOS
 dw BTAN
 dw BPI

dummyf:
 ret

PRO_REG:
;regvars Registervariablennamen, die je 1 word sind
 DB 'AXBXCXDXBPDISICSDSESFLER'

;Ende der Syntaxtabellen


CCBIG:
;konvertiert 'a'-'z' in 'A'-'Z' in Register AL
 cmp  al,'a'
 jb   ret
 cmp  al,'z'
 ja   ret
 sub  al,020h
 ret


TFIND:
;teste, ob das im Quelltext ab SI stehende
;Wort in der Tabelle ab DI zu finden ist und
;liefere Token / Tabellenendetoken
;Das Quellwort kann mit einem Punkt abgekrzt
;sein.
;in:  SI: Zeiger auf Quelltextwort
;     DI: Zeiger auf Tabellenanfang
;out: SI: Zeiger hinter Quellwort
;     AX: Token (AL: Code, AH:Spezialinfo(Bit5-0))
 clr  ah
 call IGNBLNK ;ignoriere Spaces (erledigt cld)
 mov  dx,si
tfind1:
 mov  si,dx
 mov  cl,[di] ;hole Tabellenwortlnge + 1
 clr  ch
 clr  ah ;ein Punkt ohne etwas davor ist keine Abkrzung
 inc  di
tfind2:
 dec  cx
 jz   tfind4 ;Wort gefunden / Tabellenende
 lodsb       ;hole Quelltextzeichen
 cmp  al,ah  ;Punkt als Abkrzung, beim ersten Zeichen noch nicht!
 jz   tfind3 ;Ende des Quellwortes -> Wort gefunden
 mov  ah,'.' ;jetzt ist Punkt erlaubt
tfind5:
 call CCBIG  ;Umwandlung Kleinbuchstaben->Groe
 scasb       ;Vergleich Quelle - Tabelle
 jz   tfind2 ;richtig, weiter vergleichen
 add  di,cx  ;falsch, also Rest des Tabellenwortes
 inc  di     ;und Adresse berspringen
 jmp  tfind1 ;weitersuchen
tfind3:
 add  di,cx  ;evtl. nichtgeprften Teil berspringen
tfind4:
 mov  ax,[di] ;Token holen
 and  ah,03fh
 ret


TEXEC:
;Befehls-Token bei [SI] ausfhren
 cld
 lodsb
 clr  ah
 add  ax,ax
 mov  di,TAB2A-0100h ;da erstes Token $80 ist
 add  di,ax
 jmp  w[di]


TAEXEC:
;Ausdrucks-Token aus AL ($A0-$FF) ausfhren
;fre: DI, DX, SI
 clr  ah
 add  ax,ax ;*2: word-Eintrge
 mov  bp,TAB3A-0140h ;da erster Tabelleneintrag fr Token $A0
 add  bp,ax
 jmp  w[bp]


TDECO:
;druckt Quelltextwort aus Tabelle DI zu dem Token aus AL
;und liefert in AH das Info (Bit5-0) zum Token
; Info Bit7-6 werden selbst ausgewertet
 mov  dl,al
 xor  bh,bh
tdeco2:
 mov  bl,[di]    ;Wortlnge+1
 mov  ax,[bx+di] ;Token aus Tabelle
 cmp  al,dl
 jz   tdeco1
 add  di,bx
 inc  di
 inc  di
 jmp  tdeco2
tdeco1:
 push ax
 dec  bl
 jz   tdeco4
 and  ah,080h
 jz   tdeco3
 mov  al,' '   ;Bit7=1: fhrendes Space
 call CHROUT
tdeco3:
 inc  di
 mov  al,[di]
 call CHROUT
 dec  bl
 jnz  tdeco3
tdeco4:
 pop  ax
 test ah,040h
 jz   tdeco5
 push ax
 mov  al,' '  ;Bit6=1: nachfolgendes Space
 call CHROUT
 pop  ax
tdeco5:
 and  ah,03fh
 ret


NERROR:
;druckt 'ERROR ' und dann Fehlernummer aus BL
;listet dann Zeile aus [CURRNT]
 PUSH BX
 CALL TOTEXTM ;Textmodus an
 clr  ax
 mov  [PRT_WAY],ax
 MOV  SI,ERMSG
 CALL PRTSTG
 POP  BX
 clr  bh     ;Fehlernummer nur in BL
 call IPRTNUM
 CALL CRLF
 MOV  SI,[CURRNT] ;hole Zeilenstartadresse
 CALL PRTLN  ;liste fehlerhafte Zeile
 JMP  RSTART


FNDLN:
;sucht die Zeile mit der Nummer BX im Programm, beginnt am
;Programmanfang
;in:  BX: Zeilennummer
;out: SI: zeigt auf Zeilenanfang der gefundenen oder nchstgreren
;         oder auf Textende
;     Flags: gefunden: NC Z,  nicht gefunden: NC NZ,  Textende: C
 mov si,TXTBGN

fndln2:
 cmp si,[TXTUNF] ;Programmende ?
 cmc
 jc fndln1   ;Ende erreicht!
 cmp [si],bx ;Zeilennummer vergleichen
 jnc fndln1  ;gefunden oder grer

FNDNXT:
;berspringt diese Zeile (SI zeigt auf Zeilennummer)
;sucht dann Zeile mit Nummer
 cld
 mov ah,0 ;Ergnzung fr Lngenbyte
 inc si ;berspringe Z.nummer
 inc si
fndln3:
 lodsb  ;Lngenbyte
 add si,ax ;Befehl berspringen
 lodsb  ;Ende-Kennung, $0d oder $0e ?
 cmp al,0eh
 jz fndln3  ;Befehlsende, nchsten Befehl berspringen
 jmp fndln2 ;Zeilenende, neue Zeile
fndln1:
 ret


FNDSKP:
;berspringt Rest dieser Zeile und findet nchste
;in:  [CURRNT] mu auf diese Zeile zeigen
;out: Flags: gefunden: NC,  Textende: C
 mov si,[CURRNT]
 cld
 mov ah,0
 inc si
 inc si
fndskp1:
 lodsb
 add si,ax
 lodsb
 cmp al,0eh
 jz fndskp1
 cmp si,[TXTUNF] ;Textende ?
 cmc
 ret


PRTSTG:
;druckt einen Text bis zu einem $00 (wird nicht gedruckt)
;oder einem $0d (wird gedruckt als $0d$0a) aus
;in:  SI: Zeiger auf Text
;out: SI: Zeiger hinter Text (hinter $0D oder $00)
 cld
 lodsb       ;Zeichen holen in AL
 or   al,al  ;wenn $00 gefunden: Ende
 jz   prtstg2
 cmp  al,0dh
 jz   prtstg1
 call CHROUT ;Zeichen drucken
 jmp  PRTSTG
prtstg1:
 call CRLF
prtstg2:
 call VERKUR
 RET

IPRTNUM:
;druckt BX als unsigned Dezimal Integer aus
 clr  ax
 mov  [FPR0],ax
 mov  [FPR0+2],bx ;Z.nr. nur 16 Bit Int
 mov  [FPR0+4],ax
 mov  cl,1

PRTNUM:
;druckt die vorzeichenbehaftete Zahl aus FPR0 rechtsjustiert
;in der in CL angegebenen Anzahl Spaces
;sollten es zu wenig Spaces sein, wird Zahl einfach so gedruckt
;falls CL>128, so wird eine Hexzahl mit CL-128 Ziffern gedruckt
;falls CL=128, Hexzahl ohne fhrende Nullen
;in:  FPR0: Zahl
;     CL: Anzahl der Spaces
 mov  di,FPR0
 test b[di+1],080h
 jz   pnum0
 jmp  pnumf0 ;Float
pnum0:
 or   cl,cl
 js   PRTH   ;Hexzahl drucken
;Dezimal Integer drucken
 mov  ax,10
 push ax     ;10 als Ende-Flag
 clr  ch     ;CH: 0
 dec  cl     ;CL: Spaces
 call CHKSGN ;teste Vorzeichen
 or   ch,ch
 jns  pnumd1 ;kein Vorzeichen, CH=0
 mov  ch,'-'
 dec  cl     ;'-' braucht Platz
pnumd1:
 mov  bx,[di+2]
 mov  dx,[di+4]
 mov  bp,10  ;Divisor =10 (bleibt bei DIVIL erhalten)
 clr  di
pnumd2:
 push cx     ;sign and spaces
 call DIVIL  ;DXBX=DXBX/DIBP,  CXAX=Rest
 pop  cx     ;sign and spaces
 push ax     ;sichere eine Ziffer (0 bis 9)
 mov  ax,bx  ;nur noch fhrende 0en ?
 or   ax,dx
 jz   pnumd3 ; ja, hchste Ziffer <>0 schon bearbeitet
 dec  cl     ;dekrementiere Spaces
 jmp  pnumd2
pnumd3:
 dec  cl
 js   pnumd4 ;keine (weiteren) Spaces
 mov  al,' ' ;Space ausgeben
 call CHROUT
 jmp  pnumd3
pnumd4:
 mov  al,ch  ;nur '-' drucken, sonst nichts
 or   al,al
 jz   pnumd5
 call CHROUT
pnumd5:
 pop  ax
 cmp  al,10  ;Ziffer ?
 jae  pnumd6 ; nein, Endeflag (10)
 add  al,'0' ;Ziffer in ASCII
 call CHROUT ;drucken
 jmp  pnumd5 ;alle Ziffern ausgeben
pnumd6:
 ret

PRTH:
;wie PRTNUM, aber Hex mit $ davor
;CL-128: Anzahl der Hexziffern (max. werden 8 gedruckt)
;CL=128: Hexzahl ohne fhrende Nullen
 mov  bx,[di+2]
 mov  dx,[di+4]
 MOV  AL,'$'
 CALL CHROUT
 SUB  CL,080H
 MOV  CH,8
PRTH3:
 mov  al,03h   ;ASCII-Zeichen '0' 4*rechtsverschoben
 push cx
 mov  cx,4
prth4:
 shl  bx,1
 rcl  dx,1
 rcl  al,1
 loop prth4
 pop  cx
 CMP  AL,'9'
 jbe  PRTH1
 ADD  AL,7
PRTH1:
 or   cl,cl
 jnz  prth5
 cmp  ch,1   ;fhrende Nullen bergehen
 jz   prth6  ;aber letzte 0 drucken
 cmp  al,'0'
 jz   prth2
 mov  cl,255 ;Ende der fhrenden 0en
prth5:
 CMP  CL,CH
 jc   prth2  ;Ziffer noch nicht ausgeben
prth6:
 CALL CHROUT
prth2:
 DEC  CH
 JNZ  PRTH3
 RET

pnumf0:
;Float-Zahl drucken
 test b[di+1],040h ;Sign - ?
 jz   pnumf00
 mov  al,'-'
 call CHROUT
pnumf00:
 mov  bx,[di] ;Exponent
 and  bx,03fffh
 jnz  pnumf01
 mov  al,'0'
 call CHROUT  ;Zahl ist 0
 mov  al,'.'
 call CHROUT  ;Punkt als Float-Kennzeichen
 ret
pnumf01:
 sub  bx,02000h
 shl  bx,1    ;10er Exp als signed int
 test b[di+7],0f0h ;hchste Stelle besetzt ?
 jnz  pnumf1
 mov  cx,4
pnumf02:
 shl  w[di+2],1 ;um 1 Stelle nach links
 rcl  w[di+4],1
 rcl  w[di+6],1
 loop pnumf02
 dec  bx   ;Exp korrigieren
pnumf1:
 or   bx,bx
 js   pnumf4 ;als e...
 jnz  pnumf2
 mov  al,'0' ;nur Nachkommastellen, also 0 davor
 call CHROUT
pnumf3:
 call pnumfu
 ret
pnumf2:
 cmp  bx,12
 jle  pnumf3 ;bis zu 12 Vorkommastellen
pnumf4:
 push bx     ;Darstellung als x.xxxeyy
 mov  bx,1
 call pnumfu
 mov  al,'e'
 call CHROUT
 pop  bx     ;Exp
 dec  bx
 mov  ax,bx
 cwd         ;Erweiterung auf 32 Bit
 mov  w[di],0   ;rekursiver Aufruf von PRTNUM
 mov  [di+2],ax ;zum Ausdrucken des Exponenten
 mov  [di+4],dx
 mov  cl,1
 call PRTNUM
 ret

pnumfu:
 mov  cl,12  ;12 Stellen maximal
pnumfu0:
 or   bx,bx
 jnz  pnumfu1
 mov  al,'.' ;Dezimalpunkt ausgeben
 call CHROUT
pnumfu1:
 dec  bx
 jns  pnumfu2
 mov  ax,[di+2] ;wenn hinterm Komma,
 or   ax,[di+4] ;beenden wenn nur noch Nullen folgen
 or   ax,[di+6]
 jz   pnumfu4
pnumfu2:
 mov  ch,4
 mov  al,03h ;'0' um 4 Bit rechtsverschoben
pnumfu3:
 shl  w[di+2],1
 rcl  w[di+4],1
 rcl  w[di+6],1
 rcl  al,1
 dec  ch
 jnz  pnumfu3
 call CHROUT
 dec  cl
 jnz  pnumfu0
pnumfu4:
 ret


PRTLN:
;Druckt eine komplette gespeicherte Basiczeile aus.
;Das Zeilenlngenbyte darf nicht ausgewertet werden.
;in:  SI: Zeiger auf Zeilenanfang (Zeilennummer)
;out: SI: auf nchste Zeile
 cld
 lodsw
 mov bx,ax
 or bx,bx
 jz prtln2 ;Zeile 0 ist Direktmodus, ohne Zeilennummer
 call IPRTNUM ;Zeilennummer
 mov  al,' '  ;dann ein Space
 call CHROUT
prtln2:
 inc si ;berspringe Lngenbyte
 cld
 lodsb
 mov  di,TAB2
 call TDECO  ;drucke Text zum Befehlstoken
 cmp  ah,01h ;werte Token-Info aus
 jnz  prtln7

prtln4:      ;$01: alles bis $0d drucken ohne bersetzung
 cld
 lodsb
 cmp  al,0dh
 jz   prtln3
 call CHROUT
 jmp  prtln4

prtln7:      ;$00/$02: alles bis $0d oder $0e, auch wenn keine Parameter
 cld
 lodsb
 cmp  al,0dh
 jz   prtln3

 cmp  al,0eh  ;Befehlstrenner ?
 jnz  prtln70
 mov  al,':'  ; : fr $0e drucken
 call CHROUT
 jmp  prtln2

prtln70:
 cmp  al,0ach ;String ?
 jnz  prtln1
 mov  al,022h ; " fr $ac drucken
 call CHROUT
 cld          ;String listen
 lodsb
 xor  ah,ah
 mov  cx,ax
 jcxz prtln72
prtln73:
 cld
 lodsb
 call CHROUT
 loop prtln73
prtln72:
 mov  al,022h
 call CHROUT
 jmp  prtln7

prtln1:
 cmp  al,0aeh
 jnz  prtln11
 mov  cl,128    ;32Bit Hex.Int.
prtln12:
 clr  ax
 cld
 mov  di,FPR0
 stosw
 movsw
 movsw
 call PRTNUM
 jmp  prtln7
prtln11:
 cmp  al,0afh
 jnz  prtln13
 mov  cl,1      ;32Bit Dez.Int.
 jmp  prtln12
prtln13:
 cmp  al,0adh   ;Float
 jnz  prtln15
 mov  di,FPR0
 cld
 movs4w
 mov  cl,1
 call PRTNUM
 jmp  prtln7
prtln15:
 cmp  al,0a6h   ;Variable ?
 jb   prtln14
 cmp  al,0abh
 ja   prtln14
 call VDECO     ;Variable, listen
 jmp  prtln7
prtln14:
 mov  di,TAB3   ;Ausdruckstoken aus Tabelle listen
 call TDECO
 jmp  prtln7

prtln3:
 call CRLF
 call VERKUR
 ret

