;Teil 3 des Basicinterpreters


STREXP:
;wertet einen Stringausdruck ab SI im Quelltext aus
;in:  SI: Textzeiger auf Ausdruck
;     BX: Adresse ab der Ergebnis abgelegt wird
;     CX: Anzahl der maximal abzulegenden Zeichen
;out: SI: Textzeiger hinter Ausdruck
;     AX: Anzahl der Zeichen im String (0 bei Flags=C)
;     BX: unverndert
;     Flags: Auswertung erfolgreich: NC
;            Fehler/kein Stringausdruck: C
 cld
 xor  ax,ax
 cmp  b[si],0ach ;$ac, Token fr Direktstring?
 stc          ;erstmal Fehlermeldung
 jnz  strexp0 ;nein, derzeit gibts nichts weiter
 inc  si
 lodsb        ;konstanter String: Anzahl Zeichen
 xor  ah,ah
 mov  di,si
 add  di,ax   ;String im Text berspringen
 push di
 cmp  ax,cx   ;nimm die kleinere Anzahl Zeichen
 jc   strexp1
 mov  ax,cx
strexp1:
 mov  cx,ax
 mov  di,bx
 rep movsb    ;Stringbytes kopieren
 pop  si
 clc          ;keine Fehler
strexp0:
 ret


;##############   ALLGEMEINE ARITHMETIKROUTINEN   ###############

;Macros:
;fdipush, fdipop, fbppush, fbppop
;Sichern die 8 Byte ab [DI] oder [BP] auf Stack bzw. holen sie vom Stack
;ohne DI oder BP zu verndern.

;CINFP       Int/Float -> Float in [DI]               BP, SI
;CFPIN       Int/Float -> Integer in [DI]             BP, SI
;NEGSGN      [DI] = 0 - [DI] Float oder Int           SI
;TWO_EX      DXBX,CXAX                           DI
;IEXP        DXBX                                DI
;IPARN       DXBX                                DI
;EXP         [DI]
;PARN        [DI]
;CHKSGN      [DI] = abs([DI]) Float oder Int,         SI
;	    wenn Vzwechsel wird Bit15 in CX negiert
;TWO_IPARN   (DXBX,CXAX)                         DI

;EXP, PARN und alle Routinen aus TAB3A legen das Ergebnis in [DI]
;ab. DI darf FPR0 oder anderes sein, aber nicht FPR1 oder FPR2.


;EXP wertet einen arithmetischen/logischen Ausdruck expr aus
;und darf rekursiv aufgerufen werden
;in:  SI: Textzeiger auf Anfang von expr
;     DI: Zeiger zur Ergebnisablage
;out: SI: hinter expr
;     DI: unverndert
;     [DI]: 8 Byte Ergebnis

;[ ]   :: optionale Angabe
;[...] :: optionale Wiederholung von [ ]

;expr  :: <expr2>[<OR oder XOR><expr2>][...]
;expr2 :: <expr3>[<AND><expr3>][...]
;expr3 :: <expr4>
;expr4 :: <expr5>[<Vergleichsoperator aus TAB8><expr5>]
;expr5 :: <expr6>[<+ oder -><expr6>][...]
;expr6 :: <expr7>[<* oder /><expr7>][...]
;expr7 :: <expr8>[<SHL oder SHR><expr8>][...]
;expr8 :: <expr9>[<^><expr9>]
;expr9 :: [+ oder - oder NOT]<variable oder zahl oder funktion oder (expr)>

EXP:
EXPR1: ;nur so als Kommentar
 call EXPR2
expr10:
 cmp b[si],086h ;logisches OR ?
 jnz expr11
 inc  si
 call CFPIN
 pushdxbx
 call EXPR2
 call CFPIN
 popdxbx
 or   [di+2],bx
 or   [di+4],dx
 jmp  expr10
expr11:
 cmp b[si],08ah ;logisches XOR ?
 jnz ret
 inc si
 call CFPIN
 pushdxbx
 call EXPR2
 call CFPIN
 popdxbx
 xor [di+2],bx
 xor [di+4],dx
 jmp expr10
 ret


EXPR2:
 call EXPR3
expr20:
 cmp  b[si],085h ;logisches AND ?
 jnz  ret
 inc  si
 call CFPIN
 pushdxbx
 call EXPR3
 call CFPIN
 popdxbx
 and  [di+2],bx
 and  [di+4],dx
 jmp  expr20


EXPR3:
EXPR4:
 call EXPR5
 mov  al,[si] ;versuche ob Relationsoperator
 cmp  al,0a0h
 jb   expr41  ; nein
 cmp  al,0a5h
 ja   expr41  ; nein
 inc  si
 push ax      ;Rel.op. sichern
 fdipush      ;1. Wert sichern
 call EXPR5   ;2. Wert (B) holen
 mov  bp,FPR2 ;1. Wert (A) zurck
 fbppop
 mov  ax,[di]
 or   ax,[bp]
 js   expr43 ;Float
;Integer-Vergleich
 mov  dx,0ffffh ;dx=-1 fr A<B
 mov  bx,[bp+2]
 sub  bx,[di+2]
 mov  ax,[bp+4]
 sbb  ax,[di+4]
 jl   expr42 ;A<B
 inc  dx     ;dx=0 fr A=B
 or   ax,bx
expr44:
 jz   expr42 ;A=B
 inc  dx     ;bleibt nur noch A>B, dx=1
expr42:
 pop  ax     ;Rel.op. zurckholen
 call TAEXEC ;liefert AX=0 fr falsch und AX=-1 fr wahr
 mov  w[di],0    ;Vergleichsergebnis: Integer
 mov  w[di+2],ax ;falsch = 0, wahr = -1
 mov  w[di+4],ax
expr41:
 ret
expr43:
;Float-Vergleich
 call CINFP
 xchg bp,di ;[DI]= Wert A, [BP]= Wert B
 call CINFP
 call FLCMP ;Vergleich
 xchg bp,di
 jmp expr42 ;Auswertung oben

;diese Routinen stehen in der Syntaxtabelle
;der Relationsoperatoren. Sie liefern
;in AX eine 0 fr Relation nicht erfllt
;und -1 fr erfllt nach Auswertung von DX
XP11:
;>=
 clr  ax
 or   dx,dx
 js   ret
 not  ax
 ret
XP12:
;<>
 clr  ax
 or   dx,dx
 jz   ret
 not  ax
 ret
XP13:
;>
 clr  ax
 dec  dx ;!!!
 js   ret
 not  ax
 ret
XP14:
;<=
 clr  ax
 dec  dx ;!!!
 jz   ret
 not  ax
 ret
XP15:
;=
 clr  ax
 or   dx,dx
 jnz  ret
 not  ax
 ret
XP16:
;<
 clr  ax
 or   dx,dx
 jns  ret
 not  ax
 ret


EXPR5:
 call EXPR6   ;werte ersten <expr6> aus
expr50:
 cmp  b[si],080h ;Addition ?
 jnz  expr52  ; nein
 inc  si
 fdipush      ; ja, sichere Wert
 call EXPR6   ;und hole zweiten <expr6>
expr51:
 mov  bp,FPR1 ;hole ersten Wert zurck
 fbppop
 mov  ax,[di]
 or   ax,[bp]
 js   expr53  ;Float Add
;Integer-Addition
 mov  ax,[bp+2]
 add  [di+2],ax
 mov  ax,[bp+4]
 adc  [di+4],ax
 jno  expr50
 mov  bx,[VARREG] ;berlauf,
 or   b[bx+44],1  ;Ergebnis bleibt,
 jmp  expr50      ;Bit0 von ER =1
expr52:
 cmp  b[si],081h ;Subtraktion ?
 jnz  expr54
 inc  si      ; ja, Textzeiger weiter
 fdipush
 call EXPR6   ;hole zweiten <expr6>
 call NEGSGN  ;sub = add des Komplements
 jmp  expr51
expr54:
 ret
expr53:
;Float-Addition
 call CINFP ;beide Summanden als Float
 xchg bp,di
 call CINFP
 xchg bp,di
 call FLADD
 jnc  expr50 ;kein Fehler, nchste + -
 mov  bx,[VARREG] ;Fehler, Floatberlauf
 or   b[bx+44],16 ;Bit4 von ER =1, Ergebnis 0
 jmp  expr50


EXPR6:
 CALL EXPR7   ;hole ersten <expr7>
expr62:
 mov  al,[si] ;Suchvergleiche mit AL
 cmp  al,082h ;Multiplikation ?
 jz   expr620 ; ja
 jmp  expr60  ; nein
expr620:
 inc  si
 fdipush      ; ja, sichere ersten Wert
 call EXPR7   ;hole zweiten Wert
 mov  bp,FPR1
 fbppop       ;1. Wert
 mov  ax,[di]
 or   ax,[bp]
 jns expr622  ;nur Integer
;Float-Multiplikation
 call CINFP
 xchg bp,di
 call CINFP
 xchg bp,di
 call FLMUL
 jnc expr62  ;kein berlauf
 mov bx,[VARREG]
 or b[bx+44],020h ;berlauf, setze Bit 5 in ER =1
 jmp expr62  ;nchste * / MOD
expr622:
;Integer-Multiplikation
 clr  cx
 call CHKSGN  ;Betrag 2. Wert
 xchg bp,di
 call CHKSGN  ;Betrag 1. Wert
 xchg bp,di
 push cx      ;Sign des Produkts
 mov  bx,[bp+2] ;DXBX = 1. Wert
 mov  dx,[bp+4]
 push di      ;Produkt-Zeiger sichern
 mov  bp,[di+2] ;DIBP = 2. Wert
 mov  di,[di+4]
 call MULTL   ;DXBX=DXBX*DIBP
 jc expr64    ;berlauf ber 32 Bit
 or dx,dx
 js expr64    ;berlauf ber 31 Bit
expr621:
 pop di       ;Ergebnis-Zeiger,  auch fr / und MOD
 pop cx       ;Sign
 or cx,cx
 jns expr623  ;Sign positiv
 negdxbx      ;sonst Ergebnis negieren
expr623:
 mov  [di+2],bx
 mov  [di+4],dx
 jmp  expr62  ;weitere * / MOD
expr64:
;berlauf bei *, Sign wie ohne Fehler,
;Betrag $7FFFFFFF, Bit2 von ER =1
 mov  al,4
 jmp  expr642
expr641:
;Division durch 0 bei / oder MOD, Betrag $7FFFFFFF
;Sign des Dividenten
 mov  al,2
expr642:
 mov  bx,0ffffh
 mov  dx,07fffh
 mov  bp,[VARREG]
 or   [bp+44],al
 jmp  expr621

expr60:
 cmp  al,083h ;Division ?
 jnz  expr65 ; nein
 inc  si     ; ja, erhhe Textzeiger
 fdipush     ;sichere Divident
 ;bei Division kommt es auf die Reihenfolge der Operanden an
 call EXPR7  ;hole Divisor (nach Ziel, nie FPR1 oder FPR2)
 mov bp,FPR1 ;Divisor in ein freies FPRx (1 und 2 sind frei)
 push di
 push si
 cld
 mov si,di
 mov di,bp
 movs4w
 pop si
 pop di
 fdipop  ;hole Divident zurck (nach Ziel)
 mov  ax,[di]
 or   ax,[bp]
 jns  expr61 ;Integer-Division
;Float-Division
 call CINFP
 xchg bp,di
 call CINFP
 xchg bp,di
 call FLDIV
 jc expr601
 jmp expr62 ;kein berlauf, kein /0 Fehler
expr601:
 mov bx,[VARREG]
 or b[bx+44],040h ;berlauf, setze Bit 6 in ER =1
 jmp expr62 ;nchste * / MOD
expr61:
;Integer-Division
 clr  cx
 call CHKSGN  ;Betrag Divisor
 xchg bp,di
 call CHKSGN  ;Betrag Divident
 xchg bp,di
 push cx      ;Sign des Quotienten
 mov  bx,[di+2] ;DXBX: Divident
 mov  dx,[di+4]
 push di      ;Quot. Zeiger sichern
 mov  di,[bp+4] ;DIBP: Divisor
 mov  bp,[bp+2]
 mov  ax,bp
 or   ax,di
 jnz expr611
 jmp expr641 ;Division durch 0
expr611:
 call DIVIL   ;DXBX=DXBX/DIBP,  CXAX=Rest
 jmp  expr621

expr65:
 cmp  al,089h ;MOD - Divisionsrest ?
 jnz  expr66 ; nein
 inc  si     ; ja, erhhe Textzeiger
 fdipush     ;sichere Divident
 call EXPR7  ;hole Divisor
 mov  bp,FPR1
 fbppop      ;Divident zurck
;Modulo immer mit Integern
;Integer-Division zu Restermittlung
 call CFPIN
 clr  cx
 call CHKSGN  ;Betrag Divisor
 xchg bp,di
 push cx
 call CFPIN
 pop  cx
 call CHKSGN  ;Betrag Divident
 xchg bp,di
 push cx      ;Sign des Quotienten
 mov  bx,[bp+2] ;DXBX: Divident
 mov  dx,[bp+4]
 push di      ;Quot. Zeiger sichern
 mov  bp,[di+2] ;DIBP: Divisor
 mov  di,[di+4]
 mov  ax,bp
 or   ax,di
 jz   expr651
 call DIVIL   ;DXBX=DXBX/DIBP,  CXAX=Rest
 mov  bx,ax
 mov  dx,cx
 jmp  expr621
expr651:
 jmp  expr641 ;Division durch 0
expr66:
 ret


EXPR7:
 call EXPR8  ;hole ersten <expr8>
 cmp  b[si],087h ;SHL (schiebe links) ?
 jnz  expr72
 inc  si
 call CFPIN
 pushdxbx
 call EXPR8  ;hole zweiten <expr8> : Verschiebung
 call CFPIN
 and  bx,003fh ;maximal 63* schieben
 mov  cx,bx
 popdxbx
 jcxz expr70
expr71:
 shl  bx,1
 rcl  dx,1
 loop expr71
expr70:
 mov  [di+2],bx
 mov  [di+4],dx
 ret
expr72:
 cmp  b[si],088h ;SHR (schiebe rechts) ?
 jnz  ret
 inc  si
 call CFPIN
 pushdxbx
 call EXPR8
 call CFPIN
 and  bx,03fh ;max. 63* schieben
 mov  cx,bx
 popdxbx
 jcxz expr73
expr74:
 shr  dx,1
 rcr  bx,1
 loop expr74
expr73:
 mov  [di+2],bx
 mov  [di+4],dx
 ret


EXPR8:
;noch ohne Fehlerbehandlung/Fallunterscheidung, korrektes Ergebnis
;derzeit nur fr Basis>0
 call EXPR9  ;hole ersten <expr9>
 cmp b[si],08bh ;^ (Potenzierung) ?
 jnz ret
 inc si
 call CINFP
 call FLLOGN
 fdipush
 call EXPR9  ;hole zweiten <expr9> (Exponent)
 call CINFP
 mov bp,FPR1
 fbppop      ;logarithmierte Basis zurck
 call FLMUL  ;a^b = exp(ln(a)*b)
 call FLEXPN
 ret


EXPR9:
 mov  al,[si]
 cmp  al,081h ;negatives Vorzeichen ?
 jnz  XP50
 inc  si
 call XP53
 call NEGSGN
 ret
XP50:
 cmp  al,084h ;logisches NOT ?
 jnz  XP54
 inc  si
 call XP53
 call CFPIN
 not  w[di+2]
 not  w[di+4]
 ret
XP54:
 cmp  al,080h ;positives Vorzeichen ? (nur berlesen)
 jnz  XP53
 inc  si
XP53:
 cld
 lodsb
 cmp  al,0a6h ;Variable, Zahl oder Funktion ?
 jb   XP41    ; nein
 jmp  TAEXEC  ;Zahl oder Funktion, endet mit ret

XP41:
 dec  si

PARN:
;Wird auch von Funktionen mit einem Parameter genutzt.
;hnlich EXP, Auswertung eines expr in ( )
;Ergebnis bei [DI]
 cld
 lodsb
 cmp  al,090h ;testen, ob Ausdruck in Klammern
 jnz  XP43
 call EXP     ;Klammerausdruck auswerten
 cld
 lodsb
 cmp  al,091h
 jnz  XP43    ;auch schlieende Klammer mu sein
 ret
XP43:        ;auch fr TWO_IPARN
 MOV  BL,142
 JMP  NERROR ;Syntaxfehler in expr


TWO_IPARN:
;wertet ein (a,b) aus, liefert a als Integer in DXBX
;und b als Integer in CXAX
;fre: DI
 cld
 lodsb
 cmp al,090h ;( ?
 jnz XP43
 call TWO_EX
 cmp b[si],091h ;) ?
 jnz XP43
 inc si
 ret


IEXP:
;wie EXP, liefert aber immer Integer in DXBX
;fre: DI
 push di
 mov  di,FPR0
 call EXP
 call CFPIN
 pop  di
 ret


IPARN:
;wie PARN, liefert aber immer Integer in DXBX
;fre: DI
 push di
 mov  di,FPR0
 call PARN
 call CFPIN
 pop  di
 ret


TWO_EX:
;erwartet ab [SI] expr1,expr2
;liefert zwei Integer, expr1 in DXBX und expr2 in CXAX
;in:  SI: Textzeiger
;out: SI: -"-
;     DXBX: erster Wert
;     CXAX: zweiter Wert
;fre: DI
 call IEXP
 pushdxbx
 cld
 lodsb
 cmp  al,092h ; , ?
 jnz  two_ex1
 call IEXP
 mov  ax,bx
 mov  cx,dx
 popdxbx
 ret
two_ex1:
 mov  bl,132  ;zu wenig Daten
 jmp  NERROR


MULTL:
;32 Bit unsigned Multiplikation
;DXBX = DXBX * DIBP
;C-Flag bei berlauf gesetzt, sonst NC
;unverndert: SI
 mov  cx,dx  ;gerechnet wird dxbx=cxbx*dibp
 or   cx,cx  ;CX*DI wird gespart, da es null sein mu
 jz   multl0 ; sonst sowieso berlauf, es wird getestet,
 or   di,di  ; ob wenigstens ein Faktor 0 ist, sonst
 jnz  multl1 ; Fehlermeldung
multl0:
 mov  ax,di  ;DI*BX, Highword mu null werden
 mul  bx     ; sonst Zahl zu gro, die CPU setzt C-Flag
 jc   multl1 ; DI = Teilergebnis (Bit31-16)
 mov  di,ax
 mov  ax,cx  ;BP*CX, Highword mu null werden
 mul  bp     ; sonst Fehlermeldung Zahl zu gro
 jc   multl1 ; DI = Summe der ersten Teilergebnisse
 add  di,ax  ; (Bit31-16), Fehler wenn hier C-Flag gesetzt
 jc   multl1
 mov  ax,bp  ;BP*BX, darf 32Bit ergeben
 mul  bx
 add  dx,di  ;DXAX = Ergebnis
 jc   multl1 ; mehr als 32Bit
 mov  bx,ax  ;nach DXBX
 clc
 ret
multl1:
 stc
 ret


DIVIL:
;32 Bit unsigned Division
;DXBX = DXBX / DIBP
;CXAX = Rest
;unverndert: SI, DIBP
 push si
 clr  si
 clr  ax
 mov  cx,32  ;fr 32 Bit
divil0:
 shl  bx,1
 rcl  dx,1
 rcl  ax,1
 rcl  si,1
 sub  ax,bp
 sbb  si,di
 jc   divil1
 or   bl,1
 loop divil0 ;zwei Schleifenenden sind
 mov  cx,si
 pop  si
 ret
divil1:
 add  ax,bp
 adc  si,di
 loop divil0 ; etwas schneller als ein Ende
 mov  cx,si
 pop  si
 ret



;###################   GLEITKOMMAROUTINEN   #######################

;Fr alle Routinen gilt:
;Register SI unbenutzt
;Fehlermeldung erfolgt mit gesetztem Carry-Flag, es ist aber trotzdem eine
;Zahl als (evtl. total unsinniges) Ergebnis vorhanden.
;Bentigter Zwischenspeicher wird auf dem Stack angelegt.
;Der Zeiger auf das Zielregister der Operation wird nicht verndert.
;Die Register DI und BP zeigen auf die Operanden.

;Name    Operation                zustzlich nicht vernderte Register
;FLADD   [DI] = [DI] + [BP]       [BP], BP
;FLSUB   [DI] = [DI] - [BP]       [BP], BP
;FLMUL   [DI] = [DI] * [BP]       [BP], BP
;FLDIV   [DI] = [DI] / [BP]       [BP], BP
;FLCMP   Vergleich [DI] und [BP]  [BP], BP, [DI], DI
;        DX = $FFFF fr <, $0000 fr =, $0001 fr >
;FLMOVR  [BP] = [DI]              [DI], DI, BX, CX, DX
;FLMOVV  [DI] = [BP]              [BP], BP, BX, CX, DX
;FLEXPG  [DI] = 10 ^ [DI]
;FLEXPN  [DI] = e ^ [DI]
;FLLOGG  [DI] = lg(abs([DI]))
;FLLOGN  [DI] = ln(abs([DI]))
;FLSQRT  [DI] = sqrt([DI])
;FLCOS   [DI] = cos([DI])  in Radiant
;FLSIN   [DI] = sin([DI])  in Radiant
;FLFIX   [DI] = fix([DI])
;FLFRAC  [DI] = frac([DI])
;FLPOLY


;Einige Float-Konstanten
CONST025:
 dw 0a000h
 db 000h,000h,000h,000h,000h,025h ;0.25=1/4
CONST1:
 dw 0a001h
 db 000h,000h,000h,000h,000h,001h ;1.0
CONST2:
 dw 0a001h
 db 000h,000h,000h,000h,000h,002h ;2.0
CONSTE:
 dw 0a001h
 db 084h,082h,081h,082h,071h,002h ;2.7182818284
CONSTLN4:
 dw 0a001h
 db 011h,036h,094h,062h,038h,001h ;ln(4)=1.3862943611
CONSTLN10:
 dw 0a001h
 db 030h,009h,085h,025h,030h,002h ;ln(10)=2.3025850930
CONST05PI:
 dw 0a001h
 db 068h,032h,096h,007h,057h,001h ;0.5*PI
CONSTPI:
 dw 0a001h
 db 036h,065h,092h,015h,014h,003h ;PI
CONST2PI:
 dw 0a001h
 db 072h,030h,085h,031h,028h,006h ;2*PI


FLSUB:
;Float-Subtraktion, [DI] = [DI] - [BP]
;sonst wie FLADD
 mov bl,040h ;Sign des Subtrahenden negieren und addieren
 jmp flsub0


FLADD:
;Float-Addition, [DI] = [DI] + [BP]
;unverndert: [BP]
;auch DI=BP erlaubt, um [DI] zu verdoppeln
;bei berlauf ist Exponent des Ergebnisses um 2
;zu klein und C-Flag gesetzt, sonst NC
;fre: SI
 mov bl,0 ;Sign nicht negieren
flsub0:
 push si
 push bp
 push w[bp+6] ;zweiten Summanden umkopieren
 push w[bp+4] ;da er modifiziert wird
 push w[bp+2] ;und Zeiger BP aktualisieren
 push w[bp]
 mov bp,sp
 xor [bp+1],bl  ;bei FLSUB Sign negieren
 cld            ;frs ganze FLADD
 mov  cx,03fffh ;Exponenten extrahieren
 mov  bx,cx
 and  cx,[di] ;cx= Exp von [DI]
 and  bx,[bp] ;bx= Exp von [BP]
 cmp  cx,bx
 jae  fladd0  ;Zahl mit dem greren Exp nach [DI]
 push di
 mov  si,di
 lodsw
 xchg ax,[bp]
 stosw
 lodsw
 xchg ax,[bp+2]
 stosw
 lodsw
 xchg ax,[bp+4]
 stosw
 lodsw
 xchg ax,[bp+6]
 stosw
 pop  di
 xchg cx,bx
fladd0:
 sub  cx,bx  ;Exponentendifferenz
 jz   fladd2 ;=0, keine Verschiebung erforderlich
 cmp  cx,6
 jb   fladd1 ;=(1..5)
; >=6, Ergebnis ist Summand mit grerem Exp,
; und der steht in [DI]
 jmp fladd61 ;ok und fertig
fladd1:
 mov  ax,[bp+3] ;schiebe Mantisse [BP] so, da sie den gleichen
 mov  [bp+2],ax ;Exp wie [DI] htte
 mov  ax,[bp+5]
 mov  [bp+4],ax
 mov  al,[bp+7]
 clr  ah        ;im hchsten Byte 00 einfgen
 mov  [bp+6],ax
 loop fladd1
fladd2:
 mov  al,[di+1] ;vergleiche die Sign
 xor  al,[bp+1]
 and  al,040h
 jnz  fladd4    ;Sign ungleich, subtrahieren
;Sign gleich, addieren
 push di
 add  di,2
 mov  si,2
 add  si,bp
 mov  cx,6 ;6 BCD-Bytes
 clc
fladd21:
 lodsb
 adc  al,[di]
 daa
 stosb
 loop fladd21
 pop  di
 jc   fladd31 ;Carry bearbeiten
fladd61:
 clc
fladd6:
 lea sp,[bp+8] ;setzt keine Flags
 pop bp
 pop si
 ret    ;fertig
fladd31:
 inc  w[di]     ;Carry: Exp erhhen
 mov  ax,[di+3] ;Mantisse verschieben
 mov  [di+2],ax
 mov  ax,[di+5]
 mov  [di+4],ax
 mov  al,[di+7]
 mov  ah,1      ;und die 01 als bertrag dazu
 mov  [di+6],ax
 mov  ax,03fffh ;Exponent zu gro ?
 and  ax,[di]
 cmp  ax,02000h+5000
 jbe  fladd61 ; nein, ok und fertig
 dec  w[di]   ; ja, also  wieder verringern
 stc          ;Fehlermeldung, Dezimalexp. ist um 2 zu klein,
 jmp fladd6   ;sonst stimmt das Ergebnis, fertig
fladd4:
;Sign ungleich, subtrahieren
 push di
 mov  bx,bp
 sub  bx,di ;bx=bp-di, also bx+di zeigt wie bp
 add  di,2
 mov  si,di
 mov  cx,6  ;6 BCD-Bytes
 clc
fladd46:
 lodsb
 sbb  al,[di+bx]
 das
 stosb
 loop fladd46
 jnc  fladd41 ;kein Borrow
;Borrow ausfhren: 0-Ziffern und Borrow in hchsten
;Stelle ignorieren
 sub  di,6  ;di wieder auf lowest BCD-Byte
 xor  b[di-1],040h ;Sign negieren (di-1 ist richtig!)
 mov  cx,6  ;6 BCD-Byte
 clc
fladd47:
 mov  al,0  ;kein xor al,al da das C-Flag erhalten bleiben mu
 sbb  al,[di]
 das
 stosb
 loop fladd47
fladd41:
 pop  di
;schiebe Ergebnis so, da hchstes Byte <>00
 mov  cx,6
fladd42:
 test b[di+7],0ffh
 jnz  fladd43
 mov  ax,[di+5]
 mov  [di+6],ax
 mov  ax,[di+3]
 mov  [di+4],ax
 mov  ah,[di+2]
 clr  al        ;hinten eine 00 einfgen
 mov  [di+2],ax ;!!
 dec  w[di]     ;verringere Exp
 loop fladd42
;nach 6 mal schieben ist schon alles 00
;jetzt auch noch Exp auf Wert fr Zahl 0 setzen
fladd5:
 push di
 mov  ax,08000h
 stosw
 clr  ax
 stosw   ;mu sein, da auch bei Exp
 stosw   ;zu klein genutzt
 stosw
 pop  di
 jmp fladd61 ;ok und fertig
fladd43:
 mov  ax,03fffh ;teste, ob Exp zu klein ist
 and  ax,[di]
 cmp  ax,02000h-4998
 jb   fladd5
 jmp fladd61 ;ok und fertig


FLMUL:
;Float-Multiplikation,  [DI] = [DI] * [BP]
;[BP] unverndert
;bei berlauf wird das C-Flag gesetzt und eine korrekte
;Mantisse, aber der maximale Exponent (9999) geliefert
;ohne berlauf C-Flags gelscht
;fre: SI
 cld
 push si
 clr  ax ;14 Byte Platz schaffen, auf 0 lschen,
 push ax ;ab SP aufwrts, nur 12 werden belegt
 push ax ;(Sicherheit)
 push ax ;krzeste Variante
 push ax
 push ax
 push ax
 push ax
 test w[di],07fffh ;ist ein Faktor 0 ?
 jz   flmul0 ;Faktor 1 =0
 test w[bp],07fffh
 jnz  flmul1 ;Faktor 2 <>0
flmul0:
;mindestens ein Faktor =0 oder Zahl wurde zu klein
;->Produkt =0
 push di
 mov ax,08000h ;Float-Kennung, Zahl 0
 stosw
 clr ax
 stosw
 stosw
 stosw
 pop di
 add sp,14 ;Stack aufrumen
 pop si
 clc  ;fehlerfrei
 ret
flmul1:
 mov  si,di
 add  si,2  ;Faktor 1 lowest BCD-Byte
 mov  di,sp ;12 Byte Ergebnispuffer lowest Byte
 add  bp,2  ;Faktor 2 lowest BCD-Byte
 mov  cl,0f0h    ;cl=$f0 zur Highnibblegewinnung
 mov  bx,flmultb ;Tabelle, kleines 1x1
 mov  dl,6 ;6 Byte Schleife Faktor 2
flmul110:
 mov  dh,6 ;6 Byte Schleife Faktor 1
 clc
 lahf ;Beginn ohne Carry
 mov ch,[bp]
 and ch,cl
flmul111:
 lodsb
 and al,0fh ;alle Lownibbles Faktor 1 mit jeweils einem Highnibble
 or al,ch   ;Faktor 2 mult. und zum schon vorhandenen addieren
 xlat
 sahf
 adc  al,[di]
 daa
 lahf
 stosb
 dec dh
 jnz flmul111
 mov al,0 ;einen evtl. Carry verarbeiten
 sahf
 adc al,[di]
 daa
 stosb
 sub si,6
 sub di,6 ;Ergebniszeiger bei jedem Druchlauf eins hher
 inc bp   ;nchstes Byte Faktor 2
 dec dl
 jnz  flmul110
;--
 ;si schon korrekt (l. Byte F.1)
 sub bp,6   ;l. Byte F.2
 mov di,sp  ;l.Byte Ergebnis
 mov cl,0fh ;cl=$0f zur Lownibblegewinnung
 mov dl,6
flmul120:
 mov dh,6
 clc
 lahf
 mov ch,[bp]
 and ch,cl
flmul121:
 lodsb
 and al,0f0h ;alle Highnibbles F.1 mit jew. einem Lownibble F.2 mult.
 or al,ch
 xlat
 sahf
 adc al,[di]
 daa
 lahf
 stosb
 dec dh
 jnz flmul121
 mov al,0
 sahf
 adc al,[di]
 daa
 stosb
 sub si,6
 sub di,6
 inc bp
 dec dl
 jnz flmul120
;dies waren beides Mult., deren Ergebnis mit 10
;multipliziert werden mu, also Ergebnis um 4 Bit
;nach oben verschieben
 mov di,sp ;l. Byte Ergebnis
 mov dl,4  ;um 4 Bit versch.
flmul125:
 shl w[di],1 ;unten 0en rein
 rcl w[di+2],1
 rcl w[di+4],1
 rcl w[di+6],1
 rcl w[di+8],1
 rcl w[di+10],1
 dec dl
 jnz flmul125
;die folgende Mult. (Lownibble * Lownibble) liefert schon
;richtiges Ergebnis
 ;si schon korrekt (l. Byte F.1)
 sub bp,6  ;l. Byte F.2
 mov di,sp ;l. Byte Ergebnis
 mov cl,4  ;cl=4 fr Schieben
 mov dl,6
flmul130:
 mov dh,6
 clc
 lahf
 mov ch,[bp]
 shl ch,cl
flmul131:
 lodsb
 and al,0fh ;alle Lownibbles F.1 mit jew. einem Lownibble F.2 mult.
 or al,ch
 xlat
 sahf
 adc al,[di]
 daa
 lahf
 stosb
 dec dh
 jnz flmul131
 mov al,0
 sahf
 adc al,[di]
 daa
 stosb
 sub si,6
 sub di,6
 inc bp
 dec dl
 jnz flmul130
;die folgende Mult. (Highnibble * Highnibble) liefert ein
;Ergebnis, da mit 100 mult. werden mu, also ein Byte
;hher in den Ergebnissammler addiert wird
 ;si schon korrekt (l. Byte F.1)
 sub bp,6  ;l. Byte F.2
 mov di,sp
 inc di    ;nicht l.Byte Ergebnis, sondern +1
 mov dl,6
flmul140:
 mov dh,6
 clc
 lahf
 mov ch,[bp]
 shr ch,cl
flmul141:
 lodsb
 and al,0f0h ;alle Highnibbles F.1 mit jew. einem Highnibble F.2 mult.
 or al,ch
 xlat
 sahf
 adc al,[di]
 daa
 lahf
 stosb
 dec dh
 jnz flmul141
 mov al,0
 sahf
 adc al,[di]
 daa
 stosb
 sub si,6
 sub di,6
 inc bp
 dec dl
 jnz flmul140
;-jetzt erstmal Exponenten auswerten
 sub si,2
 mov di,si ;auf Exp F.1
 sub bp,8 ;auf Exp F.2
 call flmuldiv
 add dx,ax     ;dx= Exponentensumme als 16 Bit signed
 mov si,sp
 test b[si+11],0ffh ;wenn berhaupt, ist nur das hchste Byte
 jnz flmul5 ;des Ergebnisses 0, dann Exp verringern
 dec dx ;und ein Byte frher (vom Low-ende) kopieren
 dec si
flmul5:
 add si,6 ;lowest nutzbares Ergebnisbyte
 push di
 inc di
 inc di
 movsw ;kopieren
 movsw
 movsw
 pop di
flmul9: ;auch fr FLDIV
 cmp dx,-4998
 jge flmul6 ;vorzeichenbehafteter Vergleich!
 jmp flmul0 ;Zahl zu klein, also =0
flmul6:
 cmp dx,5000
 jle flmul7
;Zahl zu gro: Mantisse und Vorzeichen korrekt, maximaler Exponent,
;C-Flag gesetzt
 mov dx,5000
 stc
 jmp flmul8
flmul7:
 clc
flmul8:
 lahf
 add dx,08000h+02000h ;Kennung und Grundwert
 or dx,bx ;Vorzeichen
 mov [di],dx
 add sp,14 ;Stack aufrumen
 pop si
 sahf
 ret

flmultb:
;kleines 1x1, beide Faktoren zusammengefat als BCD-gepackt
;von $00 bis $99 als Index in Tabelle, Ergebnis ist
;Produkt BCD gepackt
 db 0h, 0h, 0h, 0h, 0h, 0h, 0h, 0h, 0h, 0h,0,0,0,0,0,0
 db 0h, 1h, 2h, 3h, 4h, 5h, 6h, 7h, 8h, 9h,0,0,0,0,0,0
 db 0h, 2h, 4h, 6h, 8h,10h,12h,14h,16h,18h,0,0,0,0,0,0
 db 0h, 3h, 6h, 9h,12h,15h,18h,21h,24h,27h,0,0,0,0,0,0
 db 0h, 4h, 8h,12h,16h,20h,24h,28h,32h,36h,0,0,0,0,0,0
 db 0h, 5h,10h,15h,20h,25h,30h,35h,40h,45h,0,0,0,0,0,0
 db 0h, 6h,12h,18h,24h,30h,36h,42h,48h,54h,0,0,0,0,0,0
 db 0h, 7h,14h,21h,28h,35h,42h,49h,56h,63h,0,0,0,0,0,0
 db 0h, 8h,16h,24h,32h,40h,48h,56h,64h,72h,0,0,0,0,0,0
 db 0h, 9h,18h,27h,36h,45h,54h,63h,72h,81h,0,0,0,0,0,0

flmuldiv:
;Exponenten/Vorzeichenaufbereitung fr FLMUL und FLDIV
;fre: CX
 mov dx,[di] ;Exponentenword Operand 1
 mov ax,[bp] ; " Operand 2
 mov bx,ax   ;bx= nur Vorzeichen des Ergebnisses
 xor bx,dx
 and bx,04000h
 and dh,03fh ;statt and dx,03fffh   dx= Exp Op.1 als 16 Bit signed
 sub dh,020h ;statt sub dx,02000h
 and ah,03fh ;statt ...   ax= Exp Op.2 als 16 Bit signed
 sub ah,020h ;statt ...   da Exp zu $2000 addiert
 ret

fldivm macro
 lodsb
 sbb al,[bp+#1]
 das
 stosb
#em


FLDIV:
;Float-Division, [DI] = [DI] / [BP]
;[BP] unverndert
;bei berlauf C-Flag gesetzt und korrekte Mantisse mit maximalem
;Exponenten, bei Division durch null C-Flag gesetzt und Divident
;als Ergebnis
;fre: SI
 cld
 test w[bp],07fffh ;etwas umstndlicher aber sicherer Test
 jz fldiv0 ;auf Division durch null, da die Routine in eine
 mov ax,[bp+2] ;Endlosschleife liefe, wenn die Mantisse null
 or ax,[bp+4] ;ist ohne das der Exponent null ist (darf normalerweise
 or ax,[bp+6] ;nicht sein, kann beim Auslesen uninitialisierter
 jnz fldiv01 ;oder gePOKEter Variablen aber vorkommen)
fldiv0:
 stc
 ret
fldiv01:
 push si
 sub sp,14 ;Platz auf Stack, ab sp 14 Byte aufwrts
 mov si,sp
 push bp
 mov bx,di ;bx= Ergebnisspeicher, Zeiger auf Exp.word
 inc di
 inc di
 xchg si,di
 push di
 clr al
 stosb
 movsw ;Divident ab sp+4 mit 7 Byte, =di
 movsw
 movsw
 mov si,bp
 inc si
 inc si
 mov bp,di ;Divisor ab sp+11 mit 7 Byte, =bp
 stosb
 movsw
 movsw
 movsw
 pop di
 clr dx ;fr Exponentenkorrektur
 test b[di+6],0f0h
 jz fldiv1
 inc dx ;Divident nach rechts schieben
 mov cx,4
fldiv11:
 shr w[di+5],1
 rcr w[di+3],1
 rcr w[di+1],1
 rcr b[di],1
 loop fldiv11
fldiv1:
 test b[bp+6],0f0h
 jz fldiv2
 dec dx ;Divisor nach rechts schieben
 mov cx,4
fldiv12:
 shr w[bp+5],1
 rcr w[bp+3],1
 rcr w[bp+1],1
 rcr b[bp],1
 loop fldiv12
fldiv2:
 clr ax
 mov [bx+2],ax ;lsche Ergebnisspeicher
 mov [bx+4],ax
 mov [bx+6],ax
 mov cx,12 ;fr 12 BCD-Ziffern
 jmp fldiv3
fldiv32:
 push cx
 mov cx,4 ;schiebe Ergebnis eine Ziffer nach links
fldiv33:
 shl w[bx+2],1
 rcl w[bx+4],1
 rcl w[bx+6],1
 ;schiebe Divident eine Ziffer nach links
 shl w[di],1
 rcl w[di+2],1
 rcl w[di+4],1
 rcl b[di+6],1
 loop fldiv33
 pop cx
fldiv3:
;Testsubtraktion Divident-Divisor
;da es nur aufs Carry(Borrow) ankommt, kann man binr statt BCD rechnen
 mov si,di
 lodsw
 sub ax,[bp]
 lodsw
 sbb ax,[bp+2]
 lodsw
 sbb ax,[bp+4]
 lodsb
 sbb al,[bp+6]
 jc fldiv31 ;Subtraktion nicht mglich
;Subtraktion Divident=Divident-Divisor in BCD-gepackt
 inc b[bx+2] ;erhhe Ergebnis
 mov si,di
 push di
 clc
 fldivm 0
 fldivm 1
 fldivm 2
 fldivm 3
 fldivm 4
 fldivm 5
 fldivm 6
 pop di
 jmp fldiv3
fldiv31:
 loop fldiv32 ;fr 12 Ziffern
 mov di,bx ;di wieder original
 pop bp ;bp wieder original
 inc dx
 shr dx,1
 jnc fldiv4
 clr dx
 mov cx,4
 test b[di+7],0f0h
 jz fldiv41
 inc dx
fldiv42:
 shr w[di+6],1
 rcr w[di+4],1
 rcr w[di+2],1
 loop fldiv42
 jmp fldiv4
fldiv41:
 shl w[di+2],1
 rcl w[di+4],1
 rcl w[di+6],1
 loop fldiv41
fldiv4:
 mov cx,dx
 call flmuldiv
 sub dx,ax
 add dx,cx
 jmp flmul9 ;Exponent in dx und Vorzeichen aus bx verarbeiten


FLCMP:
;Float-Vergleich [DI] mit [BP]
;unverndert: [DI], [BP]
;out: DX=1  : [DI] > [BP]
;     DX=0  : [DI] = [BP]
;     DX=-1 : [DI] < [BP]
;fre: SI
 mov ax,[di]
 mov bx,[bp]
 mov cx,ax
 xor cx,bx
 test ch,040h
 jz flcmp1
;Vorzeichen sind ungleich -> der negative Wert ist kleiner
 mov dx,1
 test ah,040h
 jz flcmp2 ;[DI]>[BP]
flcmp3:
 neg dx
flcmp2:
 ret
flcmp1:
;Vorzeichen sind gleich, evtl. unterscheiden sich die Exponenten
 mov cx,ax   ;gemeinsames Vorzeichen sichern
 and ah,03fh ;statt and ax,03fffh
 and bh,03fh
 mov dx,1
 test ch,040h ;fr negative Zahlen liefert Betragsvergleich
 jz flcmp4    ;das entgegengesetzte Ergebnis
 neg dx       ;deshalb hier DX umkehren
flcmp4:
 cmp ax,bx   ;selbst die Null pat in den Exponentenvergleich !
 ja flcmp2   ;|[DI]|>|[BP]|
 jb flcmp3   ;|[DI]|<|[BP]|
;Vorzeichen und Exponenten sind gleich, Mantissen vergleichen
 mov ax,[di+6] ;Binrvergleich statt BCD mglich
 cmp ax,[bp+6] ;hchste Stellen zuerst
 ja flcmp2
 jb flcmp3
 mov ax,[di+4]
 cmp ax,[bp+4]
 ja flcmp2
 jb flcmp3
 mov ax,[di+2]
 cmp ax,[bp+2]
 ja flcmp2
 jb flcmp3
 clr dx ;[DI]=[BP]
 ret


FLMOVR:
;Float-Transport [BP] = [DI]
;unverndert: [DI]
;fre: SI, BX, CX, DX
 cld
 push di
 push si
 mov si,di
 mov di,bp
 movs4w
 pop si
 pop di
 ret


FLMOVV:
;Float-Transport [DI] = [BP]
;unverndert: [BP]
;fre: SI, BX, CX, DX
 cld
 push di
 push si
 mov si,bp
 movs4w
 pop si
 pop di
 ret


FLFRAC:
;Float-Vorkommastellen auf 0 setzen
;[DI] = [DI] ohne Vorkommastellen
;fre: SI
 mov ax,[di]
 and ah,03fh
 cmp ax,02000h
 jbe flfrac1 ;es sind nur Nachkommastellen
 cmp ax,02006h
 jae flfix4  ;Zahl = 0
 mov bx,7    ;einige Nachkommastellen
 sub bl,al
flfrac4:
 test b[di+bx],0ffh ;erstes Byte <>0 nach dem Komma suchen
 jnz flfrac2
 dec bl
 inc al
 cmp bl,2
 jae flfrac4
 jmp flfix4  ;Zahl = 0
flfrac2:
 mov ah,0
 sub [di],ax ;Exponent korrigieren
 mov cx,6
 sub cx,ax   ;soviel Byte verschieben
 push di
flfrac3:
 mov dl,[di+bx]
 mov [di+7],dl
 dec di
 loop flfrac3
 mov cx,ax   ;soviel Byte = 0
flfrac5:
 mov b[di+7],0 ;Byte lschen
 dec di
 loop flfrac5
 pop di
flfrac1:
 ret


FLFIX:
;Float-Nachkommastellen auf 0 setzen
;[DI] = [DI] ohne Nachkommastellen
;fre: SI
 mov bx,7
 mov ax,[di]
 and ah,03fh
 cmp ax,02000h
 ja flfix1
flfix4:
;Zahl = 0, auch fr FLFRAC, FLEXPG, FLPOLY
 mov [di],08000h
 clr ax
 mov [di+2],ax
 mov [di+4],ax
 mov [di+6],ax
 ret
flfix1:
 cmp ax,02005h
 ja flfix2      ;nichts auf 0
 sub bl,al
flfix3:
 mov b[di+bx],0 ;einige Byte = 0
 dec bl
 cmp bl,2
 jae flfix3
flfix2:
 ret


FLLOGG:
;Float-dekadischer Logaritmus [DI] = lg [DI]
;bei Fehler gesetztes C-Flag und irgendeine Zahl
;fre: SI
 call FLLOGN
 pushf
 mov bp,CONSTLN10
 call FLDIV
 popf
 ret


FLLOGN:
;Float-natrlicher Logarithmus [DI] = ln [DI]
;bei Fehler gesetztes C-Flag und irgendeine Zahl
;fre: SI
 push si
 sub sp,16    ;Platz fr 2 Floats auf Stack
 mov si,sp    ;SI zeigt auf ersten
 mov ax,[di]
 test ah,040h
 jnz fllogn00  ;negativ, Fehler
 and ax,03fffh ;nicht krzen, wegen Flagsetzen
 jnz fllogn1
fllogn00:
 stc           ;Ende mit Fehler
fllogn0:
 lea sp,[si+16] ;statt add sp,16  denn es setzt kein Flag
 pop si
 ret
fllogn1:
;[SI](float) = Zehnerexponent von [DI],
;so da dann 1<=[DI](float)<10 ist
 sub ax,02001h ;Hunderterexp.
 shl ax,1      ;Zehnerexp.
 test b[di+7],0f0h ;hchste Stelle besetzt ?
 jz fllogn11   ;nein, so stimmt es
 mov cx,4
fllogn12:
 shr w[di+6],1 ;passend schieben
 rcr w[di+4],1
 rcr w[di+2],1
 loop fllogn12
 inc ax ;Exp. koorigieren
fllogn11:
 mov w[di],0a001h ;passender Exp. fr [DI]
 cwd        ;Zehnerexp. in 32 Bit
 mov w[si],0
 mov [si+2],ax
 mov [si+4],dx
 xchg di,si
 call CINFP ;Zehnerexp. in float
;Wert fr lg in Wert fr ln : [SI]=[SI]*ln(10)
 mov bp,CONSTLN10
 call FLMUL
 xchg di,si
;[DI] so oft mit 0.25 multiplizieren, da 0.5<=[DI]<=2,
;dabei wird [SI] jeweils um ln(4) erhht
;denn nur dann konvergiert die Reihe schon nach 10 Iterationen
fllogn2:
 mov bp,CONST2
 call FLCMP  ;[DI]<2 ?
 or dx,dx
 js fllogn21 ;[DI]<2
 mov bp,CONST025
 call FLMUL  ;[DI]=[DI]*0.25
 xchg di,si
 mov bp,CONSTLN4
 call FLADD  ;[SI]=[SI]+ln(4)
 xchg di,si
 jmp fllogn2
fllogn21:
;[DI]=([DI]-1)/([DI]+1)
 lea bp,[si+8]
 call FLMOVR
 push di
 mov di,bp
 mov bp,CONST1
 call FLADD
 pop di
 call FLSUB
 lea bp,[si+8]
 call FLDIV
 mov cx,0010bh ;Polynom Typ 1, 11 Koeffizienten
 mov bp,fllogn9
 call FLPOLY
;[DI]=[DI]+[DI]+[SI]
 mov bp,di
 call FLADD
 mov bp,si
 call FLADD  ;liefert immer Flag NC
 jmp fllogn0 ;ok und fertig
fllogn9:
 dw 0a001h
 db 000h,000h,000h,000h,000h,001h ;1.0
 dw 0a000h
 db 033h,033h,033h,033h,033h,033h ;0.333333333333
 dw 0a000h
 db 000h,000h,000h,000h,000h,020h ;0.2
 dw 0a000h
 db 057h,028h,014h,057h,028h,014h ;0.142857142857
 dw 0a000h
 db 011h,011h,011h,011h,011h,011h ;0.111111111111
 dw 0a000h
 db 009h,009h,009h,009h,009h,009h ;0.090909090909
 dw 0a000h
 db 023h,069h,007h,023h,069h,007h ;0.076923076923
 dw 0a000h
 db 066h,066h,066h,066h,066h,006h ;0.066666666666
 dw 0a000h
 db 011h,094h,052h,023h,088h,005h ;0.058823529411
 dw 0a000h
 db 047h,089h,057h,031h,026h,005h ;0.052631578947
 dw 0a000h
 db 019h,076h,004h,019h,076h,004h ;0.047619047619


FLPOLY:
;berechnet ein Polynom
;in:  [DI]: Float-Wert x
;     BP: Zeiger auf Float-Koeffizienten (a0 steht zuerst)
;     CH: Typ des Polynoms:
;         0: a0+a1*x^1+a2*x^2+a3*x^3...
;         1: a0*x^1+a1*x^3+a2*x^5
;     CL: Anzahl der Koeffizienten
;out: [DI] Ergebnis
;fre: SI
 push si
 sub sp,30 ;Platz fr 3 Floats und 3 Words
 mov si,sp ;als Zeiger
 mov [si+24],di ;[SI+24] :: Speicher fr DI
 mov [si+26],bp ;[SI+26] :: Speicher fr BP
 mov [si+28],cl ;[SI+28] :: Speicher fr CL
 or ch,ch
 jnz flpoly3
;fr Polynom Typ 0 initialisieren
 mov bp,si
 call FLMOVR ;[SI] :: Faktor fr Potenzierung = x
 lea bp,[si+8]
 call FLMOVR ;[SI+8] :: Potenzen von x, erstmal = x
 dec b[si+28]
 mov bp,[si+26]
 call FLMOVV ;[DI] :: Ergebnissammlung, erstmal = a0
 add w[si+26],8
 jmp flpoly1
flpoly3:
;fr Polynom Typ 1 initialisieren
 lea bp,[si+8]
 call FLMOVR ;[SI+8] :: Potenzen von x, erstmal = x
 call FLMUL
 mov bp,si
 call FLMOVR ;[SI] :: Faktor fr Potenzierung = x*x
 call flfix4 ;[DI] :: Ergebnissammlung, erstmal = 0
 jmp flpoly1
flpoly1:
 lea di,[si+16] ;[SI+16] :: Zwischenergebnis ai*x^i
 lea bp,[si+8]
 call FLMOVV
 mov bp,[si+26]
 call FLMUL
 mov bp,di
 mov di,[si+24]
 call FLADD
 dec b[si+28]
 jz flpoly2 ;alles abgearbeitet
 add w[si+26],8
 lea di,[si+8]
 lea bp,[si]
 call FLMUL
 jmp flpoly1
flpoly2:
 add sp,30
 pop si
 ret


FLEXPN:
;float-Exponentialfunktion [DI] = e^[DI]
;zu groer Eingabewert liefert ein gesetztes C-Flag
;und irgendeine Zahl
;fre: SI
 mov bp,CONSTLN10
 call FLDIV ;[DI]=[DI]/ln(10)
;luft weiter in FLEXPG


FLEXPG:
;float-Exponentialfunktion [DI] = 10^[DI]
;zu groer Eingabewert liefert ein gesetztes C-Flag
;und irgendeine Zahl
;fre: SI
 push si
 sub sp,12 ;Platz fr 1 Float und 2 Words
 mov si,sp
 clr cx
 call CHKSGN      ;[DI]=abs[DI], CX(Bit15) <-- Sign
 mov [si+10],cx   ;[SI+10]word :: Sign
 cmp w[di],0a002h ;bis +9999.xxx rechnen
 jbe flexpg1 ;kleiner 10000
 or cx,cx    ;wenn Eingabe negativ, dann Ergebnis 0
 stc
 jns flexpg2 ;sonst Fehlermeldung, Ergebnis irgendeine Zahl
 call flfix4 ;[DI]=0
 clc
flexpg2:
 lea sp,[si+12] ;setzt keine Flags
 pop si         ;Ende
 ret
flexpg1:
 mov bp,si   ;Vorkommaanteil bestimmen
 xchg bp,di
 call FLMOVV ;gleich als Integer
 call CFPIN  ;in BX
 mov [si+8],bx ;[SI+8]word :: als Dezimalexponent
 xchg bp,di
 call FLFRAC ;[DI]=frac([DI])
 mov cx,10   ;10 Koeffizienten
 mov bp,flexpg0 ;Koeffizienten
 call FLPOLY ;Polynom berechnen
 mov bp,si
 call FLMOVR
 call FLMUL  ;[DI]=[DI]^2
 push di     ;aus dem Dezimalexpo. eine Zahl
 mov bp,si   ;basteln, mit der multipliziert wird
 mov di,CONST1
 call FLMOVR
 pop di
 mov bl,1
 mov ax,[si+8] ;Dezimalexpo.
 shr ax,1    ;Hunderterexpo.
 jnc flexpg3 ;stimmt so
 mov bl,010h
flexpg3:
 mov [bp+7],bl
 add [bp],ax
 call FLMUL
 test b[si+11],080h ;Sign testen
 clc
 jz flexpg2  ;Ende
 mov bp,si   ;[DI]=1/[DI]
 call FLMOVR
 mov bp,CONST1
 call FLMOVV
 mov bp,si
 call FLDIV
 clc
 jmp flexpg2 ;Ende

flexpg0:
;Original Atari XL Mathe ROM Koeffizienten
;nur der erste um eine 9 ergnzt
;da die Koeffi. nur fr 9 Stellen Genauigkeit sind,
;liefern sie auch hier nur 9 genaue Stellen
 dw 0a000h
 db 090h,099h,099h,099h,099h,099h
 dw 0a001h
 db 000h,055h,092h,012h,015h,001h
 dw 0a000h
 db 000h,050h,030h,037h,027h,066h
 dw 0a000h
 db 000h,075h,056h,034h,043h,025h
 dw 0a000h
 db 000h,041h,027h,003h,032h,007h
 dw 0a000h
 db 000h,036h,030h,060h,068h,001h
 dw 09fffh
 db 000h,000h,027h,062h,019h,032h
 dw 09fffh
 db 000h,000h,062h,076h,054h,005h
 dw 09ffeh
 db 000h,000h,000h,005h,033h,057h
 dw 09ffeh
 db 000h,000h,000h,019h,094h,017h


FLSQRT:
;float-Quadratwurzel [DI]=sqrt([DI])
;bei negativem Eingabewert ist C-Flag gesetzt und
;Ergebnis irgendeine Zahl
;fre: SI
 test w[di],07fffh
 clc
 jz flsqrt1  ;0=sqrt(0), blo nicht auf Logarithmus loslassen
 test b[di+1],040h
 stc
 jnz flsqrt1 ;Fehler: negativ
 call FLLOGG ;Logarithmus
 mov bp,CONST2
 call FLDIV  ;Division durch 2
 call FLEXPG ;Exponential (sollte immer Flag NC liefern)
flsqrt1:
 ret


FLCOS:
;float-Cosinus [DI]=cos([DI])    Winkel in Radiant
;fre: SI
 mov bp,CONST05PI ;cos(x)=sin(x+0.5*pi)
 call FLADD       ;weiterlaufen in FLSIN


FLSIN:
;float-Sinus [DI]=sin([DI])      Winkel in Radiant
;fre: SI
 push si
 push w[di+6]
 push w[di+4]
 push w[di+2]
 push w[di]
 mov si,sp
 and b[si+1],0bfh ;Sign in Kopie auf +
 clr cx
 call CHKSGN ;Betrag bilden
 push cx     ;Sign-Flag
;in Bereich 0<=x<2PI bringen
 mov bp,CONST2PI
 call FLCMP
 or dx,dx
 js flsin1  ;x<2PI
;x=x-FIX(x/(2PI))*2PI
 xchg di,si
 call FLDIV
 call FLFIX
 mov bp,CONST2PI
 call FLMUL
 xchg di,si
 mov bp,si
 call FLSUB
flsin1:
;auf 0<=x<PI bringen
 mov bp,CONSTPI
 call FLCMP
 or dx,dx
 js flsin3
 call FLSUB
 pop cx
 xor ch,080h ;Sign negieren
 push cx
flsin3:
;auf 0<=x<=PI/2 bringen
 mov bp,CONST05PI
 call FLCMP
 dec dx
 js flsin4
 mov bp,si
 call FLMOVR
 mov bp,CONSTPI
 call FLMOVV
 mov bp,si
 call FLSUB
flsin4:
 mov cx,0109h
 mov bp,flsin9
 call FLPOLY
 pop cx
 shr cx,1
 cmp w[di],08000h ;wenn Ergebnis = 0,
 jz flsin5        ;keine -0 daraus machen
 xor [di+1],ch
flsin5:
 add sp,8
 pop si
 ret
flsin9:
 dw 0a001h
 db 000h,000h,000h,000h,000h,001h ;+1/1!
 dw 0e000h
 db 067h,066h,066h,066h,066h,016h ;-1/3!
 dw 09fffh
 db 033h,033h,033h,033h,033h,083h ;+1/5!
 dw 0dfffh
 db 041h,098h,026h,041h,098h,001h ;-1/7!
 dw 09ffeh
 db 024h,092h,031h,057h,075h,002h ;+1/9!
 dw 0dffdh
 db 085h,083h,010h,052h,050h,002h ;-1/11!
 dw 09ffch
 db 037h,038h,004h,059h,060h,001h ;+1/13!
 dw 0dffah
 db 082h,031h,037h,016h,047h,076h ;-1/15!
 dw 09ff9h
 db 035h,054h,072h,045h,011h,028h ;+1/17!


CHKSGN:
;Betrag bei [DI] (Float-Register) bilden
;falls [DI] negativ war, wird Bit 15 von CX invertiert
;fre: SI
 test b[di+1],080h ;Float oder Integer ?
 jnz  chksgn1
 test b[di+5],080h ;Integer, Sign
 jns  ret          ;Zahl ist positiv
 xor  ch,080h
 not  w[di+2]
 not  w[di+4]
 add  w[di+2],1
 adc  w[di+4],0
 ret
chksgn1:
 test b[di+1],040h ;Float, Sign
 jz   ret
 xor  ch,080h
 and  b[di+1],0bfh
 ret

NEGSGN:
;Float/Integer [DI] = 0 - [DI]
;fre: SI
 test b[di+1],080h
 jnz  negsgn0
 not  w[di+2] ;Int, Zweierkomplement
 not  w[di+4]
 add  w[di+2],1
 adc  w[di+4],0
 ret
negsgn0:
 cmp  w[di],08000h ;nur wenn <>0,
 xor  b[di+1],040h ;Float-Vorzeichenwechsel
 ret
