;Zusatz zum Portfolio-Basic fr die Ansteuerung des Logikanalysators
;(C) SWB 1993, 03.06.1993

sysclk_l equ 06ch ;Offset Systemuhr lowest byte (in $0040)
sysclk_seg equ 040h ;Segment -"-
lptbas_o equ 008h ;Offset des LPT-I/O-Adrespeichers
lptbas_s equ 040h ;Segment -"-

O_XYINLI = 00100h ;(0,1) Beginn der allgemeinen Eingabezeile
O_XYMSLI = 00200h ;(0,2) Beginn einer zustzlichen Statuszeile

;nicht unbedingt im File bereits notwendige Variablen
O_RAMSEG: dw 0 ;Segmentadr. Beginn des reservierten RAM
O_OLDSP:  dw 0 ;alter Stackpointer, fr direkte Rckkehr
O_FILLEN: dw 0 ;Filelnge fr I/O
O_FILOFF: dw 0 ;Startadr Offset
O_FILSEG: dw 0 ;Startadr Segment

O_HLCHAR:  db '_','*' ;ASCII-Zeichen fr Low und High
O_BUFLEN:  dw 02000h ;Gre des Oszi-RAM = Puffergren
O_LPTADR:  dw 00378h ;Basisadresse des genutzten LPTx-Ports
O_TIMESPP: dw 040h   ;Zeiteinheiten pro Bildzeile (auch Bytezugriff legal)
O_TIMES34: dw 030h   ;3/4 von O_TIMESPP


;Folgendes mu so hintereinander stehen
O_DAT0:
O_LP0:     dw 0 ;Anfangspos. der Darstellung des Oszi0
O_KP0:     dw 0 ;Kursor0 Position im Bild, also 0..63
O_MP0:     dw 0 ;absolute Pos. des Marker0
O_BUF0S:   dw 0 ;Segmentadr des Puffers
;je Name genau 6 Byte, wenn erforderlich mit Space ergnzt
O_NAMES0:  db 'bit0  bit1  bit2  bit3  bit4  bit5  bit6  bit7  '
;Obiges fr Oszi1 nochmal
O_DAT1:
O_LP1:     dw 0
O_KP1:     dw 0
O_MP1:     dw 0
O_BUF1S:   dw 0
O_NAMES1:  db 'bit0  bit1  bit2  bit3  bit4  bit5  bit6  bit7  '

O_DATLEN = O_DAT1-O_DAT0

O_TUPD:    db 0ffh ;<>0 erlaubt Timeupdate

;Kursorstring, das Space vor/hinter lscht alten Kursor beim schieben
O_KURSTG:  db ' ^ ',0

;Bedienhinweise
O_BHWO0: db '<<<-[W]  <-[E]  [R]->  [T]->>>',0
O_BHWO1: db '<<<-[X]  <-[C]  [V]->  [B]->>>',0
;Titelzeile
O_BHWL0: db '-- Druckerport-Logikanalysator --    (C)SWB 1993     Ende mit [ESC]',0dh

O_MSGSAVE: db 'Save: ',0
O_MSGLOAD: db 'Load: ',0
O_MSGWRITE: db 'Write block: ',0
O_MSGREAD: db 'Read block: ',0
O_MSGIOERR: db ' - Error during I/O-operation. Press a key.',0
O_MSGFIND: db 'Find level combination: ',0

O_SYSINIT:
;wird am Anfang aufgerufen, um Kommandozeile (Cl) zu interpretieren
;und Variablen zu initialisieren
;Cl endet mit $0D
;in:   /
;out:  C-Flag gesetzt fr "sofort beenden"
 push ds      ;Basisadresse des LPT1 aus BIOS-Variablen holen
 mov ax,lptbas_s
 mov ds,ax
 mov ax,[lptbas_o]
 pop ds
 mov [O_LPTADR],ax

 cld
 mov si,0080h ;DS:SI zeigt auf Cl
 clr dx       ;0 fr LPT1 als default
 lodsb
 cmp al,2     ;weniger als 2 Zeichen sind immer sinnlos
 jc o_sys_nl  ;-> keine Optionen
o_sys_i:
 lodsb
 cmp al,' '   ;Leerzeichen ignorieren
 jz o_sys_cc

 cmp al,'/'   ;jetzt mu ein / folgen
 jnz o_sys_nl ;nein, Unsinn oder Ende in Cl -> Ende des Abgrasens
 lodsb        ;das mu eine gltige Option sein
 call CCBIG   ;in Grobuchstaben

 cmp al,'P'   ;/Px mit x=1, 2, 3 fr LPT1, 2, 3 Benutzung
 jnz o_sys_00
 lodsb
 sub al,'1'
 jc o_sys_nl  ;Zeichen < '1'
 cmp al,3
 jnc o_sys_nl ;Wert > 2
 shl al,1     ;Adr. sind words
 clr bx
 mov bl,al
 push ds      ;Basisadresse des LPTx aus BIOS-Variablen holen
 mov ax,lptbas_s
 mov ds,ax
 mov ax,[lptbas_o+bx]
 pop ds
 mov [O_LPTADR],ax
 jmp o_sys_cc

o_sys_00:
 cmp al,'R'   ;/R8 fr 8KByte Oszi (default), /R32 fr 32KByte
 jnz o_sys_10
 mov dx,02000h ;=8KByte
 lodsb
 cmp al,'8'
 jz o_sys_01
 cmp al,'3'
 jnz o_sys_nl ;Unsinn
 lodsb
 cmp al,'2'
 jnz o_sys_nl ;Unsinn
 mov dx,08000h ;=32KByte
o_sys_01:
 mov [O_BUFLEN],dx ;Pufferlnge speichern
 jmp o_sys_cc

o_sys_10:
 cmp al,'A'   ;/Axxx mit xxx= eine Dezimal- oder Hex($xxx)-Zahl
 jnz o_sys_20 ;fr Direktangabe der LPT-Port-Basisadresse
 call TSTNUM  ;die Funktion kann mehr als ntig
 cmp al,0aeh  ;Zahlentyp testen
 jz o_sys_11
 cmp al,0efh
 jnz o_sys_nl ;entweder keine Zahl oder Float -> Unsinn
o_sys_11:
 mov ax,[FPR0+2]   ;Lowword reicht
 mov [O_LPTADR],ax ;speichern
 jmp o_sys_cc

o_sys_20:
 jmp o_sys_nl ;derzeit keine weiteren Optionen vorhanden

o_sys_cc:
 loop o_sys_i ;Cl abgrasen

o_sys_nl:

;Speicher fr die beiden Oszi-Puffer holen
 mov bx,[O_BUFLEN]
 mov cl,3    ;Byte -> Paragraphen = /16, 2 Puffer = *2
 shr bx,cl   ;Anzahl der Paragraphen
 mov ah,048h
 int 021h    ;INT$21 Func$48: Speicher holen
 jc o_sys_e  ;Speicher reicht nicht
 mov [O_RAMSEG],ax ;Segmentadr. des reservierten RAM fr Freigabe speichern
 mov [O_BUF0S],ax  ;Segmentadr. Puffer 0 speichern
 mov bx,[O_BUFLEN] ;addiere Pufferlnge in Paragraphen
 mov cl,4
 shr bx,cl
 add ax,bx
 mov [O_BUF1S],ax  ;Segmentadr. Puffer 1 speichern
 clc               ;fehlerfrei
o_sys_e:
;C-Flag ist noch vom INT gesetzt falls Fehler
 ret


O_DEINIT:
;wird vor Ende aufgerufen und beseitigt oszispezifische Spuren
 push es
 mov es,[O_RAMSEG] ;reservierten Speicher freigeben
 mov ah,049h
 int 021h         ;INT$21 Func$49 Speicher freigeben
 pop es
 ret


O_SHOWGRAPH:
;zeigt O_TIMESSP Zeiteinheiten der 8 Kanle horizontal an
;in:   ES Segment der Oszidaten (Beginn bei Offset 0)
;      SI Offset in ES auf erste anzuzeigende Zeiteinheit
;      DL,DH x,y-Koordinate der linken oberen Ecke der Darstellung
 push ds
 mov ds,[SCRNADR]    ;Startsegment Textscreen
 mov di,dx           ;x-Koordinate *2
 and di,000ffh
 shl di,1
 clr ax              ;y-Koordinate *160
 mov al,dh
 mov cx,160
 mul cx
 add di,ax           ;DS:DI Zeiger im Bildspeicher
 cs: mov ch,[O_TIMESPP]  ;Zeiteinheiten=Zeichen pro Zeile
o_shgr_c:
 es: mov dl,[si]
 inc si
 clr bx      ;Offset fr Zeile+0 bis +7
 mov cl,08h  ;8 Bit
o_shgr_b:
 cs: mov ax,[O_HLCHAR] ;Low-Symbol im Lowbyte
 shr dl,1              ;Bit ins C-Flag
 jnc o_shgr_0          ;hops: LOW-Symbol ausgeben
 mov al,ah             ;HIGH-Symbol ausgeben
o_shgr_0:
 mov [di+bx],al ;Zeichen in Bildspeicher
 add bx,160     ;nchste Zeile
 dec cl         ;nchstes Bit
 jnz o_shgr_b
 inc di         ;nchste Zeichenadresse
 inc di
 dec ch
 jnz o_shgr_c   ;nchstes Zeichen
 pop ds
 ret


O_READOSZI:
;(greift direkt auf Druckerport zu)
;liest O_BUFLEN Bytes aus dem Oszi in den RAM
;in:   ES Segmentadresse des Puffers
 clr di      ;ES:DI Zeiger auf Ablageadr
 mov dx,[O_LPTADR]
 mov cx,[O_BUFLEN]  ;Anzahl der Byte
 mov al,040h ;Bitnummer in D2..D0
o_rdos_b:
 out dx,al
 mov ah,al
 inc dx      ;auf Statusport
 in al,dx
 in al,dx
 in al,dx
 in al,dx
 shl al,1    ;Bit7 ist /BUSY, negierte BUSY-Leitung vom LPT-Port
 rcl bl,1
 dec dx      ;auf Datenport
 mov al,ah
 inc al      ;nchstes Bit
 test al,007h
 jnz o_rdos_b
 not bl      ;da BUSY negiert gelesen wurde
 es: mov [di],bl ;speichern
 inc di
 mov al,000h
 out dx,al   ;D6 auf L, Zhlimpuls
 out dx,al
 out dx,al
 out dx,al
 mov al,040h ;Bitnummer wieder ab 0
 out dx,al   ;D6 auf H (schon hier, da es enden knnte)
 out dx,al
 out dx,al
 loop o_rdos_b ;alle Byte holen
 ret


O_RUNOSZI:
;(greift direkt auf Druckerport zu)
;startet den Oszi und wartet auf Ende des Laufes
 mov dx,[O_LPTADR]
 mov al,060h ;Oszi-Reset
 out dx,al
 out dx,al
 out dx,al
 out dx,al
 mov al,040h ;Oszi loslassen
 out dx,al
;warte auf Beendigung des Oszi-Laufes
 push es
 mov ax,sysclk_seg     ;Segment Systemuhr
 mov es,ax
 es: mov al,[sysclk_l] ;Systemuhr Lowest Byte, mit 18.2Hz wird gezhlt
o_ruos_0:
 es: cmp al,[sysclk_l]
 jz o_ruos_0       ;zweimal warten auf Ungleichheit sichert >= 1/18.2 Sekunden
 es: mov al,[sysclk_l]
o_ruos_1:
 es: cmp al,[sysclk_l]
 jz o_ruos_1
 pop es
 ret


O_COUNTLEVEL:
;ermittelt fr alle 8 Kanle, wieviel Einheiten der Pegel unterm Zeiger
;lang ist
;in:   ES Segment der Oszidaten (Beginn bei Offset 0)
;      SI Offset in ES auf zu betrachtende Einheit
;      DI Zeiger auf Array of WORDs, 8 words mit Lngen fr Bit0..7
;out:  Array of WORDs gefllt
 mov ax,1         ;Zhler auf 1 initialisieren
 mov [di],ax
 mov [2+di],ax
 mov [4+di],ax
 mov [6+di],ax
 mov [8+di],ax
 mov [10+di],ax
 mov [12+di],ax
 mov [14+di],ax

 push si          ;Startadr sichern fr Abwrtsverfolgung
 es: mov ah,[si]  ;aktuelle Pegel
 not ah           ;negieren, damit XOR spter ein 1-Bit als = liefert
 mov dl,0ffh      ;Pegel nur verfolgen, wenn entspr. Bit hier noch 1 ist
 mov cx,[O_BUFLEN]
 sub cx,si        ;Pufferlnge-aktuelle_Position-1
 dec cx           ;max. soviel Byte aufwrts verfolgen
 jz o_cole_i      ;aufwrts gehts nicht weiter
o_cole_0:
 inc si           ;nchste Position
 es: mov al,[si]  ;Pegel holen
 mov bx,14        ;Zeiger auf Zhler, down-counter
 xor al,ah        ;bit=1 bedeutet Gleichheit (siehe NOT oben)
 and al,dl        ;nur die zu verfolgenden knnten = sein
o_cole_2:
;Byte abarbeiten
 shl dl,1         ;schiebe Maske links, bit0 =0 (aktuelles bit)
		  ;wenn Maskenbit=0 war, bleibt es wegen obigem AND 0
 rol al,1         ;war es 1, so wird es 0, wenn hier ungleich
 jnc o_cole_1     ;hier ungleich oder nicht mehr verfolgen
 inc w[bx+di]     ;Einheitenzhler des bits erhhen (C-Flag unbeeinflut)
 or dl,001h       ;akt. Maskenbit wieder setzen
o_cole_1:
 dec bx
 dec bx
 jns o_cole_2     ;Byte noch nicht fertig
 or dl,dl
 jz o_cole_i      ;kein Bit mehr aufwrts zu verfolgen
 loop o_cole_0    ;oder bis Pufferende suchen

o_cole_i:
;Abwrtsverfolgung beginnen
 pop si
 mov dl,0ffh      ;Pegel nur verfolgen, wenn entspr. Bit hier noch 1 ist
o_cole_4:
 or si,si
 jz o_cole_e      ;Kursor am Pufferanfang, Ende
 dec si           ;nchste Position
 es: mov al,[si]  ;Pegel holen
 mov bx,14        ;Offset zum Zeiger auf Zhler, down-counter
 xor al,ah        ;bit=1 bedeutet Gleichheit (siehe NOT oben)
 and al,dl        ;nur die zu verfolgenden knnten = sein
o_cole_6:
;Byte abarbeiten
 shl dl,1         ;schiebe Maske links, bit0 =0 (aktuelles bit)
		  ;wenn Maskenbit=0 war, bleibt es wegen obigem AND 0
 rol al,1         ;war es 1, so wird es 0, wenn hier ungleich
 jnc o_cole_5     ;hier ungleich oder nicht mehr verfolgen
 inc w[bx+di]     ;Einheitenzhler des bits erhhen (C-Flag unbeeinflut)
 or dl,001h       ;akt. Maskenbit wieder setzen
o_cole_5:
 dec bx
 dec bx
 jns o_cole_6     ;Byte noch nicht fertig
 or dl,dl
 jnz o_cole_4     ;noch Bits aufwrts verfolgen

o_cole_e:
 ret


O_SETCURSOR:
;positioniert den Kursor auf x,y (im Clipping)
;in:   DL,DH x,y
;kill: AX
 mov ah,01h   ;x-Position
 mov al,080h
 add al,dl
 call PFSE_C
 mov al,01h   ;y-Position
 mov al,040h
 add al,dh
 call PFSE_C
 ret


O_SHOWNAMES:
;schreibt die 8 Signalnamen aufs Bild
;in:   SI: Zeiger auf Signalnamenfeld
;      DL,DH: x,y Position des ersten Zeichens erster Name auf Bild
 mov cx,8     ;8 Namen
o_shna_l:
 push cx
 push dx
 call O_SETCURSOR
 cld
 mov cx,6     ;6 Zeichen pro Name
o_shna_c:
 lodsb
 mov ah,0
 call PFSE_C
 loop o_shna_c
 pop dx
 pop cx
 inc dh       ;nchste Zeile
 loop o_shna_l
 ret


O_SHOWTIMES:
;berechnet die Zeiten und zeigt sie an
;in:   BX Segemtadr. des Oszipuffers
;      DL,DH x,y Bildschirmkoordindaten
;      SI Offset im Oszipuffer, Suchstartpunkt
 sub sp,16
 mov di,sp  ;8 words Platz fr Pegellngen
 push dx
 push es
 mov es,bx
 push di
 call O_COUNTLEVEL
 pop di
 pop es
 pop dx
 mov cx,8     ;8 Zahlen
o_shti_l:
 mov bx,[di]  ;Zahl holen
 push di
 push dx
 push cx
 call O_SHOWPOSNUM
 pop cx
 pop dx
 pop di
 inc dh       ;nchste Y-Position fr nchste Zahl
 inc di       ;Adr. der nchsten Zahl
 inc di
 loop o_shti_l
 add sp,16
 ret


O_SHOWPOSNUM:
;schreibt die Zahl positioniert & rechtsjustiert in 6 Spaces aufs Bild
;in:   DL,DH: x,y Koordinate
;      BX: Zahl -32768..32767
 call O_SETCURSOR
 clr ax
 mov  [FPR0],ax
 mov  [FPR0+2],bx ;Z.nr. nur 16 Bit Int
 mov ax,bx
 cwd              ;Vorzeichen von AX auf DX erweitern
 mov  [FPR0+4],dx
 mov  cl,6
 call PRTNUM
 ret


O_IGFN:
;gibt Text aus, erwartet Filenameneingabe (alles in Befehlszeile)
;in:   SI: Zeiger auf Textstring
;out:  DX: Zeiger auf Filename (Ende mit $00)
;      C-Flag gesetzt bei ungltigem Namen
 push si
 mov dx,O_XYINLI  ;Position der Dialogzeile
 call O_SETCURSOR
 pop si
 call PRTSTG      ;Text ausgeben
 mov si,080h      ;in der alten Kommandoszeile ist Platz
 call GFSE_AL     ;im Restplatz der Zeile editieren lassen
 mov di,si        ;suche $0D und ersetze durch $00
 mov cx,81        ;lnger wird die Zeile nie
 mov al,00dh      ;Return-Zeichen
 cld
 repnz scasb      ;suche String ab bis gefunden
 dec di           ;ist immer hinter gefundenem Byte
 mov b[di],0      ;$00 als neue Ende-Kennung
 mov dx,si        ;Zeiger in DX, passend fr Fopen/Fcreate
 cmp di,si        ;leerer String?
 stc
 jz o_igfn0
 clc
o_igfn0:
 ret



;Bitkonstanten fr das Bildupdate
O_OBMASKE = 001h ;Bildrahmenzeugs
O_SNAMEN  = 002h ;Signalnamen
O_OG0     = 004h ;Oszillogramm 0
O_OG1     = 008h ;Oszillogramm 1
O_CU0     = 010h ;Cursor0
O_CU1     = 020h ;Cursor1
O_ALL     = 0ffh ;alles


;Die Tastenfunktionen. Sie enden normalerweise mit RET und
;liefern in CL das Updateflag (nur mit OR reinschreiben)

o_ko0l:
;Oszi 0 Schritt links
 mov bx,O_LP0
 mov ch,O_OG0
o_koxl:
;Oszi x Schritt links
 cmp w[bx],0
 jz o_koxl_0
 dec w[bx]
 or cl,ch
o_koxl_0:
 ret

o_ko1l:
;Oszi 1 Schritt links
 mov bx,O_LP1
 mov ch,O_OG1
 jmp o_koxl

o_ko0r:
;Oszi 0 Schritt rechts
 mov bx,O_LP0
 mov ch,O_OG0
o_koxr:
;Oszi x Schritt rechts
 mov ax,[O_BUFLEN]
 sub ax,[O_TIMESPP]
 cmp [bx],ax
 jnc o_koxr_0
 inc w[bx]
 or cl,ch
o_koxr_0:
 ret

o_ko1r:
;Oszi 1 Schritt rechts
 mov bx,O_LP1
 mov ch,O_OG1
 jmp o_koxr

o_ko0sl:
;Oszi 0 Sprung links
 mov bx,O_LP0
 mov ch,O_OG0
o_koxsl:
;Oszi x Sprung links
 mov ax,[O_TIMES34]
 cmp [bx],ax
 jc o_koxsl_0
 sub [bx],ax
 or cl,ch
o_koxsl_0:
 ret

o_ko1sl:
;Oszi 1 Sprung links
 mov bx,O_LP1
 mov ch,O_OG1
 jmp o_koxsl

o_ko0sr:
;Oszi 0 Sprung rechts
 mov bx,O_LP0
 mov ch,O_OG0
o_koxsr:
;Oszi x Sprung rechts
 mov ax,[O_BUFLEN]
 sub ax,[O_TIMESPP]
 sub ax,[O_TIMES34]
 cmp [bx],ax
 jnc o_koxsr_0
 mov ax,[O_TIMES34]
 add [bx],ax
 or cl,ch
o_koxsr_0:
 ret

o_ko1sr:
;Oszi 1 Sprung rechts
 mov bx,O_LP1
 mov ch,O_OG1
 jmp o_koxsr

o_ko9l:
;beide Oszi Schritt links
 mov di,o_koxl ;Adresse der Schritt links Routine
 ;luft in nchste Funktion rein

o_ko9_a:
;beide Oszi bewegen
 push di
 mov bx,O_LP0
 mov ch,O_OG0
 push w[bx]     ;alte Position Oszi0
 call di        ;Oszi0 bewegen
 pop ax
 pop di
 cmp ax,[O_LP0]
 jz o_ko9_a0    ;Abbruch, Oszi0 unbeweglich
 push ax        ;alte P. Oszi0 wird gebraucht falls Oszi1 unbeweglich
 mov bx,O_LP1
 mov ch,O_OG1
 push w[bx]     ;alte Position Oszi1
 call di        ;Oszi1 bewegen
 pop ax         ;alte P. Oszi1
 pop bx         ;alte P. Oszi0
 cmp ax,[O_LP1]
 jnz o_ko9_a0   ;beide Oszis bewegt, fertig
 mov [O_LP0],bx ;Oszi1 unbeweglich, alte P. Oszi0 wieder herstellen
o_ko9_a0:
;evtl sinnlos gesetztes Updateflag strt nicht
 ret

o_ko9r:
;beide Oszi Schritt rechts
 mov di,o_koxr
 jmp o_ko9_a

o_ko9sl:
;beide Oszi Sprung links
 mov di,o_koxsl
 jmp o_ko9_a

o_ko9sr:
;beide Oszi Sprung rechts
 mov di,o_koxsr
 jmp o_ko9_a

o_kquit:
 call O_DEINIT
 mov sp,[O_OLDSP]  ;auf Position vom Start
 ret               ;Rckkehr zum aufrufenden Teil

o_ko0o:
;Oszi0 starten&lesen
 mov bx,[O_BUF0S]
 mov ch,O_OG0
o_koxo:
;Oszi x starten&lesen
 push cx
 push bx
 call O_RUNOSZI
 pop bx
 push es
 mov es,bx
 call O_READOSZI
 pop es
 pop cx
 or cl,ch
 ret

o_ko1o:
;Oszi1 starten&lesen
 mov bx,[O_BUF1S]
 mov ch,O_OG1
 jmp o_koxo

o_ktupd0:
;Timeupdate aus
 mov b[O_TUPD],0
 mov cl,O_ALL
 ret

o_ktupd1:
;Timeupdate an
 mov b[O_TUPD],0ffh
 mov cl,O_ALL
 ret

o_curleft macro
;Kursor #1 links
 cmp w[O_KP#1],0
 jz >M1          ;Ende erreicht
 dec w[O_KP#1]
 or cl,O_CU#1
M1:
 ret
#em

o_kcu0l:
;Kursor0 links
 o_curleft 0

o_kcu1l:
;Kursor1 links
 o_curleft 1

o_curright macro
;Kursor #1 rechts
 cmp w[O_KP#1],0003fh
 jnc >M1       ;Ende erreicht
 inc w[O_KP#1]
 or cl,O_CU#1
M1:
 ret
#em

o_kcu0r:
;Kursor0 rechts
 o_curright 0

o_kcu1r:
;Kursor1 rechts
 o_curright 1

o_ilevl:
 db 'Zeichen fr  L-Pegel:',0
o_ilevh:
 db '  H-Pegel',0

o_kalta:
;Zeichen fr L- und H-Pegel eingeben
 mov dx,O_XYINLI
 call O_SETCURSOR
 mov si,o_ilevl
 call PRTSTG
o_kalta0:
 call GETKEY   ;Zeichen fr L holen
 or ah,ah
 jnz o_kalta0  ;erweiterter Code nicht erlaubt
 mov [O_HLCHAR],al
 call PFSE_C
 mov si,o_ilevh
 call PRTSTG
o_kalta1:
 call GETKEY   ;Zeichen fr H holen
 or ah,ah
 jnz o_kalta1  ;erweiterter Code nicht erlaubt
 mov [O_HLCHAR+1],al
 mov cl,O_ALL  ;alles updaten
 ret

o_setmark macro
;setzt Marker #1 (0 oder 1)
 mov ax,[O_LP#1] ;absolute Bildposition
 add ax,[O_KP#1] ;Kursor relativ im Bild
 mov [O_MP#1],ax ;Marker absolut
 or cl,O_CU#1
 ret
#em

o_kma0:
;setze Marker0
 o_setmark 0

o_kma1:
;setze Marker1
 o_setmark 1

o_oscopy macro
;kopiert Oszi #1 nach #2
 cld
 mov cx,O_DATLEN
 mov si,#1
 mov di,#2
 rep movsb
 mov cl,O_ALL
 ret
#em

o_kdown:
;kopiert oberen Oszi nach unten
 o_oscopy O_DAT0,O_DAT1

o_kup:
;kopiert unteren Oszi nach oben
 o_oscopy O_DAT1,O_DAT0

o_kchg:
;tauscht beide Oszi gegeneinander
 cld
 mov cx,O_DATLEN
 mov si,O_DAT1
 mov di,O_DAT0
o_kchg0:
 mov al,[di]
 xchg al,[si]
 inc si
 stosb
 loop o_kchg0
 mov cl,O_ALL
 ret


o_ksave:
;speichert Oszi0 in File
 mov cx,[O_BUFLEN] ;Lnge
 clr dx            ;Startadr Offset
 mov bx,[O_BUF0S]  ;Startadr Segment
 mov si,O_MSGSAVE  ;Meldung
o_ksavx:
;fr Save und Write
 mov [O_FILLEN],cx  ;Lnge
 mov [O_FILOFF],dx  ;Startadr Offset
 mov [O_FILSEG],bx  ;Startadr Segment
 call O_IGFN     ;Meldung, Filename holen
 jc o_ksav2      ;kein Filename, Funktion beenden
 push dx         ;Adresse Filename sichern (zum evtl. Lschen der Datei)
 clr cx          ;Dateiattribut
 mov ax,03c00h
 int 021h        ;INT$21 Func$3C: Datei anlegen
 pop dx
 jc o_ksav1      ;Fehler beim ffnen
 push dx
 push ax         ;Handle sichern
 mov bx,ax       ;Handle fr Fwrite
 mov cx,[O_FILLEN] ;Anzahl der Byte
 mov dx,[O_FILOFF] ;Puffer-Offset
 push ds
 mov ds,[O_FILSEG] ;Puffer-Segment
 mov ah,040h
 int 021h        ;INT$21 Func$40: Bytes schreiben
 pop ds
 pop bx          ;Handle holen
 push ax         ;Anzahl wirklich gespeicherter Byte
 pushf           ;Flags sichern
 mov ah,03eh
 int 021h        ;INT$21 Func$3E: Datei schlieen
 popf            ;Flags holen
 pop ax          ;Byteanzahl
 pop dx          ;Adresse Filename
 jc o_ksav3      ;Fehler beim Schreiben
;leider liefert der Portfolio auch ein Carry, wenn er weniger
;Byte als angegeben geschrieben hat (normaler PC nicht)
;aber die geschriebene Bytezahl in AX ist ein Vielfaches von 080H,
;und echte Fehlernummern sind kleiner
 cmp [O_FILLEN],ax ;dieser Test erfolgt nur, falls DOS-Fehler entfllt
 jz o_ksav2      ;alles ok.
 mov al,0        ;fr Disk voll
o_ksav3:
 push ax         ;Fehlernummer sichern
 mov ah,041h
 int  021h       ;INT$21 Func$41: Datei lschen
 pop ax
 test al,07fh    ;wegen des Portfolio-DOS-Fehlers nochmal auf Disk voll testen
 jnz o_ksav1     ;anderer Fehler
 mov al,0        ;Fehler Disk voll
o_ksav1:
;allgemein fr Save, Load, Write, Read
 mov ah,0          ;Fehler melden
 mov bx,ax
 mov dx,O_XYMSLI
 call O_SHOWPOSNUM ;Fehlernummer
 mov si,O_MSGIOERR
 call PRTSTG       ;Fehlermeldung
 call GETKEY       ;warte auf Tastendruck
o_ksav2:
;allgemein fr Save, Load, Write, Read
 mov cl,O_ALL
 ret


o_kload:
;ldt Oszi0 aus File
 mov si,O_MSGLOAD  ;Text
 mov cx,[O_BUFLEN] ;Lnge
 clr dx            ;Startadr Offset
 mov bx,[O_BUF0S]  ;Startadr Segment
o_kloax:
;fr Load und Read
 mov [O_FILLEN],cx ;Lnge
 mov [O_FILOFF],dx ;Startadr Offset
 mov [O_FILSEG],bx ;Startadr Segment
 call O_IGFN
 jc   o_ksav2      ;kein Filename
 MOV  AX,03D00H
 INT  021H         ;INT$21 Func$3D: Datei ffnen
 JC   o_ksav1      ;Fehler melden
 PUSH AX           ;handle sichern
 MOV  BX,AX        ;handle
 mov cx,[O_FILLEN] ;maximal zu lesende Byte
 mov dx,[O_FILOFF] ;Offset Startadr
 push ds
 mov ds,[O_FILSEG] ;Segment Startadr
 MOV  AH,03FH
 INT  021H         ;INT$21 Func$3F: Byte lesen
 pop ds
 POP  BX           ;handle
 PUSH AX           ;Anzahl gelesener Byte
 PUSHF             ;Flags
 MOV  AH,03EH
 INT  021H         ;INT$21 Func$3E: Datei schlieen
 POPF
 POP  AX
 jc o_ksav1        ;Fehler melden
 cmp [O_FILLEN],ax
 jz o_ksav2        ;ok, auch soviel Byte geladen
 mov al,0
 jmp o_ksav1       ;weniger Byte geladen, mu nicht Fehler sein


o_kread:
;ldt Teil aus File in Oszi0, ab Marker, max. bis inclusive Kursor
 mov di,o_kloax    ;Adr der Routine
 mov si,O_MSGREAD  ;Meldung
o_kreax:
;auch fr Write
 mov dx,[O_MP0]    ;Startadr Offset
 mov al,255        ;Fehlermeldung fr "Kursor links vom Marker"
 mov cx,[O_KP0]    ;Lnge: Kursor+Bild-Marker+1
 add cx,[O_LP0]
 sub cx,[O_MP0]
 jb o_ksav1        ;Kursor links vom Marker, nichts tun
 inc cx
 mov bx,[O_BUF0S]  ;Startadr Segment
 jmp di            ;laden oder speichern


o_kwrite:
;schreibt Teil von Oszi0 in File, von Marker bis inclusive Kursor
 mov di,o_ksavx    ;Adr der Routine
 mov si,O_MSGWRITE ;Meldung
 jmp o_kreax


o_kfind:
;sucht im Oszi0 ab Kursor nach rechts nach einzugebender Signalkombination
 mov dx,O_XYINLI
 call O_SETCURSOR
 mov si,O_MSGFIND
 call PRTSTG
 mov si,080h      ;wieder mal Kommandozeile als Puffer
 call GFSE_AL
 mov cl,001h      ;rotierendes Bit, zuerst Bit0
 clr dx           ;DH als AND-Maske zum Ausblenden, DL als Suchbyte
 cld
o_kfin3:
 lodsb
 cmp al,00dh
 jz o_kfin4       ;Ende der Eingabe, suche Byte
 cmp [O_HLCHAR+1],al ;Zeichen fr High?
 jnz o_kfin1      ;nein
 or dl,cl         ;setze Bit im Suchbyte
 or dh,cl         ;setze Bit in Suchmaske
 jmp o_kfin2
o_kfin1:
 cmp [O_HLCHAR],al ;Zeichen fr Low?
 jnz o_kfin2      ;nein
 or dh,cl         ;setze Bit in Suchmaske
o_kfin2:
 shl cl,1         ;nchstes Zeichen nchstes Bit
 jnc o_kfin3      ;bis alle 8 eingegeben sind
o_kfin4:
 mov si,[O_KP0]   ;Start ab: Kursor + Bild
 add si,[O_LP0]
 mov cx,[O_BUFLEN] ;max. Suchweite ermitteln
 sub cx,si
 push ds
 mov ds,[O_BUF0S]  ;Segmentadresse
o_kfin5:
 lodsb
 and al,dh        ;Suchmaske anwenden
 cmp al,dl
 loopnz o_kfin5   ;weitersuchen / gefunden?
 pop ds
 jnz o_kfin0      ;nicht gefunden, nichts bewegen
 dec si           ;zeigte hinter Fundstelle
 mov cx,[O_TIMESPP] ;angestrebt wird Kursor in Bildmitte, aber am Ende
 shr cx,1           ;und Anfang nicht mglich
 cmp si,cx       ;(virtuell Kursor auf 1/2Bild, und Bild auf Fund-1/2Bild)
 jnc o_kfin6     ;keine Anfangs-Korrektur
 mov cx,si       ;Anfangs-Korrektur: Bild auf 0, Kursor entsprechend
 clr si
 jmp o_kfin7
o_kfin6:
 sub si,cx       ;(real Kursor auf 1/2Bild, ...)
 mov ax,[O_BUFLEN] ;End-Korrektur erforderlich?
 sub ax,[O_TIMESPP]
 sub ax,si
 jnc o_kfin7     ;keine End-Korrektur
 add si,ax       ;End-Korrektur: in AX steht der negative Korrektursummand
 sub cx,ax       ;Kursor weiter nach rechts
o_kfin7:
 mov [O_LP0],si  ;neue Bildposition
 mov [O_KP0],cx  ;neue Kursorposition
o_kfin0:
 mov cl,O_ALL
 ret


;Tabelle der Tastenfunktionen
;Eintrge:
;BYTE ascii_Tcodeteil, BYTE erweiterter_Tcodeteil, WORD Adr_der_Subroutine
O_KCTAB:
 db 'W',0
 dw o_ko0sl ;0 <<
 db 'E',0
 dw o_ko0l  ;0 <
 db 'R',0
 dw o_ko0r  ;0 >
 db 'T',0
 dw o_ko0sr ;0 >>

 db 'X',0
 dw o_ko1sl ;1 <<
 db 'C',0
 dw o_ko1l  ;1 <
 db 'V',0
 dw o_ko1r  ;1 >
 db 'B',0
 dw o_ko1sr ;1 >>

 db 'S',0
 dw o_ko9sl ;beide <<
 db 'D',0
 dw o_ko9l  ;beide <
 db 'F',0
 dw o_ko9r  ;beide >
 db 'G',0
 dw o_ko9sr ;beide >>

 db 'Q',0
 dw o_kcu0l ;Kursor0 <
 db 'Z',0
 dw o_kcu0r ;Kursor0 >
 db 'Y',0
 dw o_kcu1l ;Kursor1 <
 db 'N',0
 dw o_kcu1r ;Kursor1 >

 db 'U',0
 dw o_kma0  ;Marker0 setzen
 db 'M',0
 dw o_kma1  ;Marker1 setzen

 db 0,01fh
 dw o_ksave  ;[ALT]+[S] Speichere Oszi0
 db 0,026h
 dw o_kload  ;[ALT]+[L] Lade Oszi0
 db 0,011h
 dw o_kwrite ;[ALT]+[W] Speichere Block von Oszi0
 db 0,013h
 dw o_kread  ;[ALT]+[R] Lade Block nach Oszi0

 db 006h,0
 dw o_kfind ;[CTRL]+[F] sucht einzugebende Pegel
 db 0,01eh
 dw o_kalta ;[ALT]+[A] Zeichen fr Logikpegel eingeben
 db 0,020h
 dw o_kdown ;[ALT]+[D] kopiere oberen Oszi nach unten
 db 0,016h
 dw o_kup   ;[ALT]+[U] kopiere unteren Oszi nach oben
 db 0,02eh
 dw o_kchg  ;[ALT]+[C] tauscht oberen gegen unteren Oszi
 db '+',0
 dw o_ktupd1 ;Timeupdate an
 db '-',0
 dw o_ktupd0 ;Timeupdate aus

 db 00dh,0  ;[RETURN] Oszi0 lesen
 dw o_ko0o
 db 00ah,0  ;[CTRL]+[RETURN] Oszi1 lesen
 dw o_ko1o
 db 01bh,0  ;[ESC] Ende
 dw o_kquit

 db 0,0     ;Tabellenende
 dw 0



;Das Oszi-Hauptprogramm (mit CALL aufzurufen)
O_HPRG:

;Initialisierung
 mov [O_OLDSP],sp   ;fr das schnelle Ende
;Kursore auf 0
 clr ax
 mov [O_LP0],ax
 mov [O_KP0],ax
 mov [O_LP1],ax
 mov [O_KP1],ax
 mov cl,O_ALL       ;alles updaten

;Hauptschleife
o_mainlp:
 test cl,O_OBMASKE
 jz o_m_10
;Bildschirm lschen, statische Elemente zeichnen
 push cx
 mov ax,013ch   ;Bildschirm lschen
 call PFSE_C
 mov si,O_BHWL0 ;Titelzeile
 call PRTSTG
 mov dx,0040ch  ;(12,4) Bedienhinweis
 call O_SETCURSOR
 mov si,O_BHWO0
 call PRTSTG
 mov dx,00f0ch  ;(12,15) Bedienhinweis
 call O_SETCURSOR
 mov si,O_BHWO1
 call PRTSTG
 pop cx
o_m_10:
 test cl,O_SNAMEN
 jz o_m_20
 ;Signalnamen ausgeben
 push cx
 mov dx,00501h    ;(1,5) fr Oszi0-Namen
 mov si,O_NAMES0
 call O_SHOWNAMES
 mov dx,01001h    ;(1,16) fr Oszi1-Namen
 mov si,O_NAMES1
 call O_SHOWNAMES
 pop cx
o_m_20:
 test cl,O_OG0
 jz o_m_30
;Oszi0 zeichnen (inkl. Positionsangabe)

o_ospaint macro
;zeichnet Oszi #1 ab Pos. #2, Pos-Angabe auf Pos #3
 push cx
 push es
 mov es,[O_BUF#1S]
 mov dx,#2
 mov si,[O_LP#1]
 call O_SHOWGRAPH
 pop es
 mov dx,#3
 mov bx,[O_LP#1]
 call O_SHOWPOSNUM
 pop cx
#em

 o_ospaint 0,00508h,00403h ;Oszi0, Position(8,5), Pos.angabe(3,4)
o_m_30:
 test cl,O_OG1
 jz o_m_40
;Oszi1 zeichnen
 o_ospaint 1,01008h,00f03h ;Oszi1, Position(8,16), Pos.angabe(3,15)
o_m_40:
 test cl,O_CU0
 jz o_m_50
;Kursor0 zeichnen

o_cuup macro
;Kursor #1 Update ab Position #2
 push cx
 mov dx,#2        ;Position
 add dl,[O_KP#1]
 call O_SETCURSOR
 mov si,O_KURSTG  ;Kursorstring
 call PRTSTG
 pop cx
#em

 o_cuup 0,00d07h  ;(8,13), x-1 wegen Stringlnge
o_m_50:
 test cl,O_CU1
 jz o_m_60
;Kursor1 zeichnen
 o_cuup 1,01807h  ;(8,24), x-1 wegen Stringlnge
o_m_60:
 test b[O_TUPD],0ffh  ;Timeupdate erlaubt?
 jz o_m_80            ;kein Timeupdate
;Time0 update wenn (erlaubt &) Cursor0 bewegt oder Oszi0 neu gezeichnet
 test cl,O_OG0+O_CU0
 jz o_m_70

o_shxtimes macro
;zeigt Zeiten von Oszi #1 auf Pos #2 und Markerpos auf Pos #3
 push cx
 mov dx,#2
 mov bx,[O_BUF#1S]
 mov si,[O_LP#1]
 add si,[O_KP#1]
 call O_SHOWTIMES
 mov dx,#3
 mov bx,[O_LP#1]
 add bx,[O_KP#1]
 sub bx,[O_MP#1]
 call O_SHOWPOSNUM
 pop cx
#em

 o_shxtimes 0,00549h,00d49h
 ;(73,5) Zeiten Oszi0, (73,13) Differenz Marker0-Kursor0
o_m_70:
;Time1 update wenn (erlaubt &) Cursor1 bewegt oder Oszi1 neu gezeichnet
 test cl,O_OG1+O_CU1
 jz o_m_80
 o_shxtimes 1,01049h,01849h
 ;(73,16) Zeiten Oszi1, (73,24) Differenz Marker1-Kursor1
o_m_80:
;Kursor0 Position update wenn Oszi0 oder Kursor0 bewegt
 test cl,O_OG0+O_CU0
 jz o_m_90

o_cuposup macro
;Update von Kursorpositionsanzeige #1 auf Position #2
 push cx
 mov bx,[O_LP#1]
 add bx,[O_KP#1]
 mov dx,#2
 call O_SHOWPOSNUM
 pop cx
#em

 o_cuposup 0,00d01h ;(1,13) Kursorpos. Oszi0
o_m_90:
;Kursor1 Pos. update wenn Oszi1 oder Kursor1 bewegt
 test cl,O_OG1+O_CU1
 jz o_m_100
 o_cuposup 1,01801h ;(1,24) Kursorpos. Oszi1
o_m_100:

 mov dx,01800h    ;Kursor auf (0,24), wo er nicht strt
 call O_SETCURSOR

o_m_201:
 call GETKEY      ;Tastendruck holen
 or ah,ah
 jnz o_m_200      ;kein ASCII, sondern ein erweiterter Tastencode
 call CCBIG       ;Buchstaben in GROSS
o_m_200:
 mov bx,O_KCTAB   ;Adr der KeyCommandTABle
 clr cx           ;Updateflag lschen und fr Tab.-ende-Test
o_m_203:
 cmp [bx],cx      ;0-word als Endezeichen
 jz o_m_201       ;unbekannte Taste, neue holen (evtl User anmeckern)
 cmp [bx],ax
 jz o_m_202       ;Taste gefunden
 add bx,4         ;nchsten Eintrag prfen
 jmp o_m_203
o_m_202:
 clr cx           ;Updateflags lschen
 call w[2+bx]     ;Routine aufrufen (Adr. steht auf [2+bx])

 jmp o_mainlp     ;Endlosschleife
;Ende wird in einer Tastenfunktion vollstndig bearbeitet
