;Teil 9 des Basicinterpreters
;Bildschirmroutinen


CRLF:
;erzeugt Carriage Return und Line Feed
 mov  al,0dh
 call CHROUT
 mov  al,0ah
 call CHROUT
 ret


CHROUT:
;gibt das Byte aus AL aus
;Alle Register bleiben erhalten
 push bx
 mov  bx,[PRT_WAY]
 shr  bh,1
 jc   chrout1 ;keine Ausgabe auf Bildschirm
 cmp  b[G_MO],128
 jz   chrout2
 push ax
 cmp  b[T_MO],1
 jnz  chrout7 ;normale Ausgabe
 mov  ah,01h   ;Ausgabe als Steuerzeichen
 mov  b[T_MO],0
 jmp  chrout6
chrout7:
 mov  ah,00h
 cmp  al,00h
 jnz  chrout6
 mov  b[T_MO],1 ;setze Flag fr Steuercode erwartet
 jmp  chrout8
chrout6:
 call PFSE_C   ;Textmodus
chrout8:
 pop  ax
 jmp  chrout1
chrout2:
 call GRTEXT   ;Graphikmodus
chrout1:
 shr  bh,1
 jnc  chrout3 ;keine Ausgabe auf LPT1
 push ax
 allpush
 push ax
chrout4:
 mov  ah,2
 xor  dx,dx
 int  017h    ;INT$17 Func$02: Status LPTx
 and  ah,080h
 jz   chrout4 ;warte auf nicht BUSY
 pop  ax
 mov  ah,0
 xor  dx,dx
 int  017h    ;INT$17 Func$00: Zeichen auf LPTx ausgeben
 allpop
 pop  ax
chrout3:
 shr  bh,1
 jnc  chrout5 ;keine Ausgabe auf FILE
 push ax      ;Ausgabe auf File-handle
 allpush
 mov  [chrouts],al
 mov  dx,chrouts
 mov  cx,0001h
 xor  bh,bh
 mov  ah,040h
 int  021h    ;INT$21 Func$40: Schreibe auf Handle
 allpop
 pop  ax
chrout5:
 pop  bx
 ret
chrouts:
 db   0       ;ein Byte als Zwischenspeicher


GETKEY:
;wartet auf Tastendruck und liefert den ASCII-Code in AL (AH=0)
;ist es ein erweiterter Code, ist AL=0 und Code in AH
 allpush
 mov  ah,7
 int  021h ;INT$21 Func$07: Zeichen lesen von Standard-Eingabe
 sub  ah,ah
 or   al,al
 jnz  getkey1 ;kein erweiterter Tastencode
 mov  ah,7
 int  021h ;INT$21 Func$07
 mov  ah,al
 sub  al,al
getkey1:
 allpop    ;erweiterter Code in AH, AL=0
 ret


GFSE_AL:
;die Kursorzeile ab Kursorposition mit dem FSE bearbeiten
;(nur mit Funktionen eines Zeileneditors)
;in:  SI: Zeiger auf Pufferanfang (81 Byte reichen)
;out: SI: -"-
;     DI: Zeiger hinter $0D im Puffer
;     AX: erweiterter Tastaturcode, mit dem der Zeileneditor verlassen
;         wurde: Return, Kursor hoch/runter, Bild hoch/runter, Ende
;         (wird nicht! mit ausgedruckt)
 push [G_AX]    ;Clipping sichern
 push [G_EX]
 mov  bx,[G_X]  ;und Clipping auf diese Zeile
 mov  [G_AX],bx
 mov  [G_EY],bh
 mov  ch,080h   ;Bit15 fr Ende beachten
 call GFSELINE
 pop  [G_EX]    ;wieder altes Clipping
 pop  [G_AX]
 ret


GFSE_L:
;eine Zeile mit dem FSE bearbeiten
;in:  SI: Zeiger auf Pufferanfang (Puffer mind. 81 Byte lang)
;out: SI: -"-
;     DI: Zeiger hinter $0D im Puffer
;     Text im Puffer, endet mit $0D
 xor  ch,ch    ;das Bit15 fr Ende (fr GFSE_AL) ignorieren
 call GFSELINE
 mov  ax,013dh
 call PFSE_C   ;$13D-RET ausgeben
 call VERKUR
 ret


GFSELINE:
;Routine fr GFSE_L und GFSE_AL
 push si
gfse4:
 call VERKUR
 call GETKEY
 mov  bx,ax    ;Tastencode
 cmp  ax,000dh ;Return-Taste ?
 jz   gfse1    ; ja
 mov  si,tabecco
 cld
gfse5:
 lodsw      ;Tab: Tastencode
 or   ax,ax
 jz   gfse2 ;Tabellenende erreicht
 cmp  ax,bx ;gefunden ? : Flags setzen
 lodsw      ;Tab: Zielcode
 jnz  gfse5 ; nein, weitersuchen
 test ah,ch ; ja, Steuercode prfen / ausgeben
 jnz  gfse1 ;Ende wegen Bit15=1
 and  ah,07fh ;Bit15 lschen
 jmp  gfse9 ; ja, Steuercode ausgeben
gfse2:
 or   bh,bh ;nicht bersetzbare erweiterte Codes ignorieren
 jnz  gfse4
 push cx    ;Bit15-Maske sichern
 push bx    ;ASCII-Code sichern
 mov  ah,2
 int  016h     ;INT$16 Func$02: lies Tastaturstatus
 or   al,al    ;nur Insert Lock (Bit 7) interessant
 jns  gfse8    ;kein Insert-Modus
 mov  ax,0139h
 call PFSE_C   ;INS ausgeben
gfse8:
 pop  ax       ;ASCII-Code
 pop  cx
gfse9:
 call PFSE_C   ;Zeichen ausgeben
 jmp  gfse4

gfse1:         ;Ende der Bearbeitung
 pop  di
 push bx       ;Tastencode des Endes sichern
 push di
 mov  dh,[G_Y] ;Kursor auf letztes Zeichen
 mov  dl,[G_EX]
 xor  cx,cx
 mov  cl,[G_EX]
 sub  cl,[G_AX]
 inc  cx       ;soviel Zeichen in einer Zeile
 call GSCRADR  ;Adresse holen
 mov  es,bx    ;Quelle DS:SI
 std           ;Decrement
 pop  di       ;Ziel   ES:DI
 push di
 add  di,cx
 dec  di       ;Zeiger vor Platz fr $0D erstmal
gfse10:
 lodsw         ;uninteressantes Attribut in AH
 stosb         ;DI+2 ist Platz fr $0D
 cmp  al,020h  ;Space ?
 loopz gfse10  ;maximal CX Space berlesen
 lahf
 mov  dx,di    ;DX+2 ist Platz fr $0D falls nicht alles Space
 inc  dx
 inc  dx       ;DX   -"-
 or   cx,cx
 jnz  gfse11   ;noch Zeichen kopieren
 sahf
 jnz  gfse12   ;1 nicht-Space, DX stimmt.
 dec  dx       ; sonst korrigieren
 jmp  gfse12   ;alles Space gewesen
gfse11:
 lodsw
 stosb
 loop gfse11
gfse12:
 mov  ds,bx    ;DS wieder herstellen
 mov  di,dx
 mov  b[di],0dh ;$0D eintragen
 inc  di       ;DI hinter $0D
 pop  si       ;SI: auf Pufferanfang
 pop  ax       ;AX: Ende-Tastencode
 ret


TABECCO:
;Tabelle fr bersetzung: 16Bit-Tastencode, 16Bit-Steuercode (Bit15
;wird auf 0 gesetzt), Ende mit 0,0
;gesetztes Bit15 im Steuercode: mit diesem Tastencode GFSE_AL
;verlassen
 dw 04b00h,00131h,04d00h,00132h,04800h,08133h,05000h,08134h
 dw 04700h,00136h,05300h,00137h,04900h,0813ah,05100h,0813bh
 dw 07300h,00137h,07400h,00139h,04f00h,08135h,07700h,0013ch
 dw 00007h,00007h,00008h,00138h,00009h,00009h,0000ah,00134h
 dw 07600h,0013eh,08400h,0013fh,00000h,00000h


VERKUR:
;verfolge nur auf Portfolio im Textmodus den Kursor
;mit dem LCD-Bild
;alle Vergleiche signed !!!
 #if portfolio
 cmp  b[G_MO],0
 jnz  verkur1 ;kein Textmodus
 push ax
 allpush
 mov  ax,01000h
 int  061h    ;INT$61 Func$10: lies LCD-Position
 mov  cx,dx
 mov  bx,[G_X]
 sub  bl,10
verkur2:
 cmp  bl,dl
 jge  verkur21
 sub  dl,10
 jmp  verkur2
verkur21:
 sub  bl,19
verkur3:
 cmp  bl,dl
 jle  verkur31
 add  dl,10
 jmp  verkur3
verkur31:
 cmp dl,0    ;statt frher [G_AX], sonst ist der Text der evtl. vor
 jge verkur4 ;INPUT steht nie zu sehen auf Portfolio
 mov dl,0    ;statt frher [G_AX]
verkur4:
 cmp  dl,40
 jle  verkur41
 mov  dl,40
verkur41:
 sub  bh,1
verkur5:
 cmp  dh,bh
 jle  verkur51
 sub  dh,1
 jmp  verkur5
verkur51:
 sub  bh,5
verkur6:
 cmp  dh,bh
 jge  verkur61
 add  dh,1
 jmp  verkur6
verkur61:
 cmp  dh,0 ;statt frher [G_AY]
 jge  verkur7
 mov  dh,0 ;statt frher [G_AY]
verkur7:
 cmp  dh,17
 jle  verkur71
 mov  dh,17
verkur71:
 cmp  dx,cx
 jz   verkur8   ;es hat sich nichts gendert
 mov  ax,01001h
 int  061h      ;INT$61 Func$10: LCD-Fenster setzen
verkur8:
 allpop
 pop  ax
verkur1:
 #endif
 ret


PFSE_C:
;gibt das word aus AX auf den Textbildschirm aus
;Steuercodes werden ausgefhrt, Clipping bercksichtigt
 push ax
 allpush
 cmp  ax,0100h
 jb   cho1
 call cho_c    ;Steuerzeichen ab $100
cho_e:
 mov  dx,[G_X] ;G_X, G_Y
 call SETBICU  ;BIOS-Kursor aktualisieren
 allpop
 pop  ax
 ret

cho1:
 cmp  al,09h ;Tabulator ?
 jnz  cho2
 mov  al,[G_X]  ;$09 TAB: zur nchsten durch 8 teilbaren
 sub  al,[G_AX] ;X-Koordinate, relativ zum Clipping
 add  al,8
 and  al,0f8h
 add  al,[G_AX]
 cmp  al,[G_EX]
 jbe  cho7      ;noch in der gleichen Zeile
 mov  ax,013dh  ;RET
 call cho_c
 jmp  cho_e
cho7:
 mov  [G_X],al
 jmp  cho_e

cho2:
 cmp  al,08h    ;Backspace ?
 jnz  cho3
 mov  al,[G_X]  ;$08 Backspace: Rckschritt
 cmp  al,[G_AX] ;maximal bis Zeilenanfang
 jbe  cho_e
 dec  b[G_X]
 jmp  cho_e

cho3:
 cmp  al,07h ;Bell ?
 jnz  cho4
 mov  ah,0eh ;$07 Bell: Piepen
 mov  bh,[G_PA]
 int  010h   ;INT$10 Func$0E: Zeichenausgabe im TTY-Modus
 jmp  cho_e

cho4:
 cmp  al,0ah   ;$0A Line Feed ?
 jnz  cho5
 mov  ax,0134h ;$134: DOWN
 call cho_c
 jmp  cho_e

cho5:
 cmp  al,0dh   ;$0D Carriage Return ?
 jnz  cho6
 mov  ax,0136h ;$136: SOL
 call cho_c
 jmp  cho_e

cho6:
;es ist ein normales Zeichen: bers BIOS ausgeben
 call cho_putc ;Zeichen ausgeben
 mov  al,[G_X] ;Kursor bearbeiten
 cmp  al,[G_EX]
 jb   cho8     ;noch in gleicher Zeile
 mov  ax,013dh ;Steuercode RET
 call cho_c
 jmp  cho_e
cho8:
 inc  b[G_X]
 jmp  cho_e

cho_putc:
;Zeichen aus AL direkt bers BIOS ausgeben
 push cx
 push dx
 push si
 mov  ah,0ah
 mov  bh,[G_PA]
 mov  cx,1     ;nur 1 Zeichen
 int  010h     ;INT$10 Func$0A: Zeichenausgabe ohne weiteres
 pop  si
 pop  dx
 pop  cx
 ret


SETBICU:
;BIOS-Textkursor auf (dl,dh) aktualisieren
 push ax
 allpush
 mov  ah,02h
 mov  bh,[G_PA]
 int  010h      ;INT$10 Func$02: Kursor setzen
 allpop
 pop  ax
 ret


GSCRADR:
;liefert Adresse des Kursors im Video-RAM
;in:  DX: DL,DH Kursor
;out: SI=DI: Adresse als Offset zum Anfang des TextvideoRAM
;     DS=ES: Segmentadr des TextvidoeRAM-Anfangs
;            ($B000 fr Hercules, $B800 fr nur-VGA)
;     BX: Codesegment CS
 sub  ax,ax
 mov  al,dh ;Zeile
 mov  si,ax
 shl  si,1
 shl  si,1
 add  si,ax
 shl  si,1
 shl  si,1
 shl  si,1
 shl  si,1  ;SI=Zeile*80
 mov  al,dl ;AH ist noch 0
 add  si,ax ;SI +Spalte
 shl  si,1  ;wegen Attributbytes
 mov  di,si
 mov  ax,[SCRNADR]
 mov  ds,ax
 mov  es,ax
 mov  bx,cs
 ret


SCRREF:
;Bildrefresh auf Portfolio, tut auf XT/AT nichts
 #if portfolio
 push ax
 allpush
 mov  ah,012h
 int  061h    ;INT$61 Func$12: LCD Screen Refresh
 allpop
 pop  ax
 #endif
 ret


cho_c:
;Steuerzeichen aus AX ausfhren (mu $100-$1FF sein)
 cmp  al,040h
 jae  cho_c1
 cmp  al,030h
 jb   ret
 and  ax,000fh ;nur $130 bis $13F stehen in Tabelle
 mov  di,tabcoco
 add  di,ax
 add  di,ax
 mov  bx,[G_X] ;bl=G_X, bh=G_Y
 jmp  w[di]    ;anspringen
cho_c1:
 cmp  al,080h
 jb   cho_c2
 and  al,07fh
 add  al,[G_AX] ;%(2)1xxxxxxx: Kursor X im Clipping setzen
 cmp  al,[G_EX]
 ja   ret
 mov  [G_X],al
 ret
cho_c2:
 and  al,03fh
 add  al,[G_AY] ;%(2)01yyyyyy: Kursor Y im Clipping setzen
 cmp  al,[G_EY]
 ja   ret
 mov  [G_Y],al
 ret


cho100:
;nichts tun $100
 ret

cho101:
;LEFT $101
 cmp  bl,[G_AX]
 ja   cho201
 call cho103     ;UP
 mov  bl,[G_EX]  ;auf Zeilenende
 mov  [G_X],bl
 ret
cho201:
 dec  b[G_X]
 ret

cho102:
;RIGHT $102
 cmp  bl,[G_EX]
 jb   cho202
 call cho104    ;DOWN
 mov  bl,[G_AX] ;auf Zeilenanfang
 mov  [G_X],bl
 ret
cho202:
 inc  b[G_X]
 ret

cho103:
;UP $103
 cmp  bh,[G_AY]
 ja   cho203
 mov  ax,0701h
 mov  cx,[G_AX]
 mov  dx,[G_EX]
 mov  bh,7   ;Attribut
 int  010h   ;INT$10 Func$07: abwrts scrollen
 mov  bh,[G_AY]
 mov  [G_Y],bh
 ret
cho203:
 dec  b[G_Y]
 ret

cho104:
;DOWN $104
 cmp  bh,[G_EY]
 jb   cho204
 mov  ax,0601h
 mov  cx,[G_AX]
 mov  dx,[G_EX]
 mov  bh,7   ;Attribut
 int  010h   ;INT$10 Func$06: aufwrts scrollen
 mov  bh,[G_EY]
 mov  [G_Y],bh
 ret
cho204:
 inc  b[G_Y]
 ret

cho105:
;HOME $105
 mov  bx,[G_AX]
 mov  [G_X],bx
 ret

cho106:
;SOL $106
 mov  bl,[G_AX]
 mov  [G_X],bl
 ret

cho107:
;DEL $107
 mov  dx,bx
 xor  cx,cx
 mov  cl,[G_EX]
 sub  cl,bl
 call GSCRADR
 cld
 inc  si
 inc  si
cho207:    ;fr cho109
 rep movsw
 mov  b[di],020h ;Space
 mov  ds,bx
 mov  es,bx
 jmp  SCRREF

cho108:
;DBS $108
 cmp  bl,[G_AX]
 jbe  ret
 dec  bl
 mov  [G_X],bl
 mov  dx,bx
 call SETBICU
 mov  al,' '
 jmp  cho_putc

cho109:
;INS $109
 mov  dx,bx
 mov  dl,[G_EX]
 xor  cx,cx
 mov  cl,dl
 sub  cl,bl
 call GSCRADR
 std
 dec  si
 dec  si
 jmp  cho207


cho10a:
;LDE $10A
 mov  ax,0601h
 mov  ch,bh
 mov  cl,[G_AX]
 mov  dx,[G_EX]
 mov  bh,7   ;Attribut
 int  010h   ;INT$10 Func$06: aufwrts scrollen
 ret

cho10b:
;LIN $10B
 mov  ax,0701h
 mov  ch,bh
 mov  cl,[G_AX]
 mov  dx,[G_EX]
 mov  bh,7   ;Attribut
 int  010h   ;INT$10 Func$07: abwrts scrollen
 ret

cho10c:
;CLS $10C
 mov  ax,0600h
 mov  cx,[G_AX]
 mov  dx,[G_EX]
 mov  [G_X],cx
 mov  bh,7   ;Attribut
 int  010h   ;INT$10 Func$06: aufwrts scrollen
 ret         ;hier benutzt zum Lschen (Zeilenzahl=0)

cho10d:
;RET $10D
 call cho106 ;SOL
 jmp  cho104 ;DOWN

cho10e:
;SCU $10E
 mov  [cho_cusa],bx
 ret

cho10f:
;RCU $10F
 mov  dx,[cho_cusa]
 cmp  dl,[G_AX]
 jb   ret
 cmp  dl,[G_EX]
 ja   ret
 cmp  dh,[G_AY]
 jb   ret
 cmp  dh,[G_EY]
 ja   ret
 mov  [G_X],dx
 ret

TABCOCO:
;Tabelle der Startadressen fr die Steuercodes $100 bis $10F
 dw cho100,cho101,cho102,cho103
 dw cho104,cho105,cho106,cho107
 dw cho108,cho109,cho10a,cho10b
 dw cho10c,cho10d,cho10e,cho10f
cho_cusa:
 dw 0 ;Kursorspeicher


;ab hier wieder Basicinterpreter

GRAPZG:
;Zeichengenerator fr Graphikmodus, derzeit $00-$7F
;Aufbau: 6*8 Punkte, spaltenweise (erstes Byte = erste Spalte)
;        im Byte ist Bit 0 (ja!) die oberste Zeile
 db 0,0,0,0,0,0         ;$00
 db 62,85,81,85,62,0    ;$01
 db 62,107,111,107,62,0
 db 30,62,124,62,30,0
 db 8,28,62,28,8,0
 db 28,95,103,95,28,0
 db 28,94,127,94,28,0
 db 0,0,24,24,0,0
 db 255,255,231,231,255,255
 db 0,24,36,36,24,0
 db 255,231,219,219,231,255
 db 48,72,77,75,55,0
 db 6,41,121,41,6,0
 db 96,96,63,5,7,0
 db 96,127,5,53,63,0
 db 42,28,119,28,42,0
 db 127,62,28,8,8,0
 db 8,8,28,62,127,0
 db 20,54,127,54,20,0
 db 0,95,0,95,0,0
 db 6,9,127,1,127,0
 db 0,74,85,85,41,0
 db 112,112,112,112,112,0
 db 84,118,127,118,84,0
 db 4,6,127,6,4,0
 db 16,48,127,48,16,0
 db 8,8,42,28,8,0
 db 8,28,42,8,8,0
 db 60,32,32,32,0,0
 db 8,28,8,28,8,0
 db 32,56,62,56,32,0
 db 2,14,62,14,2,0
 db 0,0,0,0,0,0       ;$20
 db 0,0,95,0,0,0      ;$21
 db 0,3,0,3,0,0
 db 20,127,20,127,20,0
 db 36,42,107,42,18,0
 db 35,19,8,100,98,0
 db 54,73,85,34,80,0
 db 0,0,5,3,0,0
 db 0,28,34,65,0,0
 db 0,65,34,28,0,0
 db 20,8,62,8,20,0
 db 8,8,62,8,8,0
 db 0,0,80,48,0,0
 db 8,8,8,8,8,0
 db 0,0,96,96,0,0
 db 32,16,8,4,2,0
 db 62,81,73,69,62,0
 db 0,66,127,64,0,0
 db 66,97,81,73,70,0
 db 33,65,69,75,49,0
 db 24,20,18,127,16,0
 db 39,69,69,69,57,0
 db 60,74,73,73,48,0
 db 1,1,121,5,3,0
 db 54,73,73,73,54,0
 db 6,73,73,41,30,0
 db 0,0,54,54,0,0
 db 0,0,86,54,0,0
 db 0,8,20,34,65,0
 db 20,20,20,20,20,0
 db 65,34,20,8,0,0
 db 2,1,81,9,6,0
 db 62,65,73,85,14,0   ;@
 db 126,17,17,17,126,0 ;A
 db 127,73,73,73,54,0  ;B
 db 62,65,65,65,34,0   ;C
 db 127,65,65,34,28,0  ;D
 db 127,73,73,73,65,0  ;E
 db 127,9,9,9,1,0      ;F
 db 62,65,81,81,114,0  ;G
 db 127,8,8,8,127,0    ;H
 db 0,65,127,65,0,0    ;I
 db 32,64,65,63,1,0    ;J
 db 127,8,20,34,65,0   ;K
 db 127,64,64,64,64,0  ;L
 db 127,2,12,2,127,0   ;M
 db 127,4,8,16,127,0   ;N
 db 62,65,65,65,62,0   ;O
 db 127,9,9,9,6,0      ;P
 db 62,65,81,33,94,0   ;Q
 db 127,9,25,41,70,0   ;R
 db 38,73,73,73,50,0   ;S
 db 1,1,127,1,1,0      ;T
 db 63,64,64,64,63,0   ;U
 db 31,32,64,32,31,0   ;V
 db 127,32,24,32,127,0 ;W
 db 99,20,8,20,99,0    ;X
 db 7,8,120,8,7,0      ;Y
 db 97,81,73,69,67,0   ;Z
 db 0,127,65,65,0,0    ;[
 db 2,4,8,16,32,0      ;\
 db 0,65,65,127,0,0    ;]
 db 4,2,1,2,4,0        ;^
 db 128,128,128,128,128,128 ;_
 db 0,3,5,0,0,0        ;$60
 db 32,84,84,84,120,0  ;a
 db 127,72,68,68,56,0  ;b
 db 56,68,68,68,32,0   ;c
 db 56,68,68,72,127,0  ;d
 db 56,84,84,84,88,0   ;e
 db 8,126,9,9,2,0      ;f
 db 8,84,84,84,60,0    ;g
 db 127,8,4,4,120,0    ;h
 db 0,68,125,64,0,0    ;i
 db 32,64,68,61,0,0    ;j
 db 127,32,16,40,68,0  ;k
 db 0,65,127,64,0,0    ;l
 db 124,4,24,4,120,0   ;m
 db 124,8,4,4,120,0    ;n
 db 56,68,68,68,56,0   ;o
 db 124,20,20,20,8,0   ;p
 db 8,20,20,20,124,0   ;q
 db 124,8,4,4,8,0      ;r
 db 72,84,84,84,36,0   ;s
 db 4,63,68,68,32,0    ;t
 db 60,64,64,32,124,0  ;u
 db 28,32,64,32,28,0   ;v
 db 60,64,48,64,60,0   ;w
 db 68,40,16,40,68,0   ;x
 db 76,80,80,80,60,0   ;y
 db 68,100,84,76,68,0  ;z
 db 0,8,62,65,65,0     ;{
 db 0,0,119,0,0,0      ;|
 db 65,65,62,8,0,0     ;}
 db 2,1,3,2,1,0      ;$7E
 db 96,80,72,80,96,0 ;$7F


tabtrot:
;Highbyte:Y Lowbyte:X Increments
;1.word:in einer Spalte   2.word:nach einer Spalte
;3.word:Incr. fr Ursprungskursor nach Zeichenausgabe
 dw 00100h,0f801h,00006h ; 0:normal links->rechts
 dw 00001h,0fff8h,0fa00h ; 6:aufwrts unten->oben
 dw 0ff00h,008ffh,000fah ;12:rckwrts rechts->links
 dw 000ffh,00108h,00600h ;18:abwrts oben->unten
 dw 001ffh,0f809h,00006h ;24:kursiv normal links->rechts
 dw 00101h,0f7f8h,0fa00h ;30:kursiv aufwrts unten->oben
 dw 0ff01h,008f7h,000fah ;36:kursiv rckwrts rechts->links
 dw 0ffffh,00908h,00600h ;42:kursiv abwrts oben->unten

GRTEXT:
;Zeichen aus AL im Graphikmodus ausgeben
 push ax
 allpush
 mov  di,[G_RO] ;Textrotation
 add  di,tabtrot
 xor  ah,ah
 add  ax,ax     ;Zeichencode * 6
 mov  si,[G_ZG] ;ZGadr.
 add  si,ax
 add  si,ax
 add  si,ax     ;SI: Adr. im ZG
 mov  cl,[G_X]  ;CL: X-Koord.
 mov  dl,[G_Y]  ;DL: Y-Koord.
 mov  bh,6      ;BH: Spaltenzhler
grtext1:
 mov  ah,8      ;AH: Zeilenzhler
 cld
 lodsb          ;Byte aus ZG
 test b[G_CO],040h ;Bit6:
 jz   grtext2   ; 0=plot fr 1-Bits
 not  al        ; 1=plot fr 0-Bits
grtext2:
 shr  al,1      ;ins C-Flag
 jnc  grtext3   ;nicht plotten
 call PLOT      ;plotten
grtext3:
 add  cl,[di+0] ;eine Zeile weiter
 add  dl,[di+1]
 dec  ah
 jnz  grtext2   ;alle 8 Zeilen bearbeiten
 add  cl,[di+2] ;eine Spalte weiter (und 8 Zeilen zurck)
 add  dl,[di+3]
 dec  bh
 jnz  grtext1
 mov  dx,[G_X]  ;Kursor ein Zeichen weiter setzen
 add  dl,[di+4]
 add  dh,[di+5]
 mov  [G_X],dx
 allpop
 pop  ax
 ret


TXTBGN: ;hier beginnt spter das Basicprogramm
MSG1:
 db 'pofo-BASIC V'
 version
 db ' by SWB 18051993 for '
 #if portfolio
 db 'Portfolio'
 #else
 db 'PC/XT/AT'
 #endif
 db 0dh

 END

